
PowerBarColor = {};
PowerBarColor["MANA"] = { r = 0.00, g = 0.00, b = 1.00 };
PowerBarColor["RAGE"] = { r = 1.00, g = 0.00, b = 0.00, fullPowerAnim=true };
PowerBarColor["FOCUS"] = { r = 1.00, g = 0.50, b = 0.25, fullPowerAnim=true };
PowerBarColor["ENERGY"] = { r = 1.00, g = 1.00, b = 0.00, fullPowerAnim=true };
PowerBarColor["COMBO_POINTS"] = { r = 1.00, g = 0.96, b = 0.41 };
PowerBarColor["RUNES"] = { r = 0.50, g = 0.50, b = 0.50 };
PowerBarColor["RUNIC_POWER"] = { r = 0.00, g = 0.82, b = 1.00 };
PowerBarColor["SOUL_SHARDS"] = { r = 0.50, g = 0.32, b = 0.55 };
PowerBarColor["LUNAR_POWER"] = { r = 0.30, g = 0.52, b = 0.90, atlas="_Druid-LunarBar" };
PowerBarColor["HOLY_POWER"] = { r = 0.95, g = 0.90, b = 0.60 };
PowerBarColor["MAELSTROM"] = { r = 0.00, g = 0.50, b = 1.00, atlas = "_Shaman-MaelstromBar", fullPowerAnim=true };
PowerBarColor["INSANITY"] = { r = 0.40, g = 0, b = 0.80, atlas = "_Priest-InsanityBar"};
PowerBarColor["CHI"] = { r = 0.71, g = 1.0, b = 0.92 };
PowerBarColor["ARCANE_CHARGES"] = { r = 0.1, g = 0.1, b = 0.98 };
PowerBarColor["FURY"] = { r = 0.788, g = 0.259, b = 0.992, atlas = "_DemonHunter-DemonicFuryBar", fullPowerAnim=true };
PowerBarColor["PAIN"] = { r = 255/255, g = 156/255, b = 0, atlas = "_DemonHunter-DemonicPainBar", fullPowerAnim=true };
-- vehicle colors
PowerBarColor["AMMOSLOT"] = { r = 0.80, g = 0.60, b = 0.00 };
PowerBarColor["FUEL"] = { r = 0.0, g = 0.55, b = 0.5 };
PowerBarColor["STAGGER"] = { {r = 0.52, g = 1.0, b = 0.52}, {r = 1.0, g = 0.98, b = 0.72}, {r = 1.0, g = 0.42, b = 0.42},};

-- these are mostly needed for a fallback case (in case the code tries to index a power token that is missing from the table,
-- it will try to index by power type instead)
PowerBarColor[0] = PowerBarColor["MANA"];
PowerBarColor[1] = PowerBarColor["RAGE"];
PowerBarColor[2] = PowerBarColor["FOCUS"];
PowerBarColor[3] = PowerBarColor["ENERGY"];
PowerBarColor[4] = PowerBarColor["CHI"];
PowerBarColor[5] = PowerBarColor["RUNES"];
PowerBarColor[6] = PowerBarColor["RUNIC_POWER"];
PowerBarColor[7] = PowerBarColor["SOUL_SHARDS"];
PowerBarColor[8] = PowerBarColor["LUNAR_POWER"];
PowerBarColor[9] = PowerBarColor["HOLY_POWER"];
PowerBarColor[11] = PowerBarColor["MAELSTROM"];
PowerBarColor[13] = PowerBarColor["INSANITY"];
PowerBarColor[17] = PowerBarColor["FURY"];
PowerBarColor[18] = PowerBarColor["PAIN"];

local PowerToken = {}
PowerToken[0] = "MANA"
PowerToken[1] = "RAGE"
PowerToken[2] = "FOCUS"
PowerToken[3] = "ENERGY"
PowerToken[4] = "CHI"
PowerToken[5] = "RUNES"
PowerToken[6] = "RUNIC_POWER"
PowerToken[7] = "SOUL_SHARDS"
PowerToken[8] = "LUNAR_POWER"
PowerToken[9] = "HOLY_POWER"
PowerToken[11] = "MAELSTROM"
PowerToken[13] = "INSANITY"
PowerToken[17] = "FURY"
PowerToken[18] = "PAIN"


local bar = _G[...]
local modName = ...
local title = "Power"
--Power Bar
local widget = bar:GetTemplate("StatusBar", title)
widget.Events = {
	["UNIT_POWER"] = 1,
}

function widget:New(parent)
	local comp = self:Bind(self:CreateNew(parent, title))

	return comp
end

local basePower = {
        [0] = {
            ["Druid"] = true,
            ["Warlock"] = true,
            ["Shaman"] = true,
            ["Mage"] = true,
            ["Monk"] = true,
            ["Paladin"] = true,
            ["Priest"] = true,
        },
        [1] = {
            ["Warrior"] = true,
            ["Druid"] = true,
        },
        [6] = {
            ["Death Knight"] = true
        },
        [3] = {
            ["Rogue"] = true,
            ["Druid"] = true,
			
        }
}

local function GetPowerType(unit)

	local class = UnitClass(unit)
	local FormIndex = GetShapeshiftForm(unit)
	local powerType = UnitPowerType(unit, FormIndex)
	if class == "Druid" then
		if FormIndex == 1 then -- Bear Form
			powerType = 1
		elseif FormIndex == 2 then -- Cat Form
			powerType = 3
		elseif FormIndex == 4 then -- The first known of: Moonkin Form, Treant Form, Stag Form (in order)
			local _, form = GetShapeshiftFormInfo(FormIndex)
			if form == "Moonkin Form" then
				powerType = 8
			end
		end
	end
	return powerType
end

function widget:UpdateType()
	local unit = self.owner.id
	local powerType = GetPowerType(unit);
	
	local powerToken = PowerToken[powerType]
		
	local color = PowerBarColor[powerType]
	
	local altR, altG, altB = color.r, color.g, color.b
	
	local info = PowerBarColor[powerToken];
	
	
	if ( info ) then
		if ( not self.lockColor ) then
			local playerDeadOrGhost = (UnitIsDead("player") or UnitIsGhost("player"));
				if ( playerDeadOrGhost ) then
					self:SetColor(0.6, 0.6, 0.6, 0.5)
				else
					self:SetColor(info.r, info.g, info.b, 1)
				end
		end
	else
		if ( not altR) then
			-- couldn't find a power token entry...default to indexing by power type or just mana if we don't have that either
			info = PowerBarColor[powerType] or PowerBarColor["MANA"];
		else
			if ( not self.lockColor ) then
				self:SetColor(altR, altG, altB, 1)
			end
		end
	end
	if ( self.powerType ~= powerType or self.powerType ~= powerType ) then
		self.powerType = powerType;
		self.powerToken = powerToken;

	end

	-- Update the manabar text
	if ( not self.noTextPrefix ) then
	--	SetTextStatusBarTextPrefix(self, prefix);
	end
	--TextStatusBar_UpdateTextString(self);
end

local ALT_MANA_BAR_PAIR_DISPLAY_INFO = {
	DRUID = {
		[Enum.PowerType.LunarPower] = true,
		
		[Enum.PowerType.Rage] = true,
		
		[Enum.PowerType.Energy] = true,
	},
	PRIEST = {
		[Enum.PowerType.Insanity] = true,
	},
	SHAMAN = {
		[Enum.PowerType.Maelstrom] = true,
	},
};

function widget:ShouldDisplayPower()
	local unit = self.owner.id
	if UnitHasVehiclePlayerFrameUI(unit) then
		return false;
	end

	if UnitPowerMax(unit, self.powerIndex) == 0 then
		return false;
	end

	local _, class = UnitClass(unit);
	if ALT_MANA_BAR_PAIR_DISPLAY_INFO[class] then
		local powerType = GetPowerType(unit);
		return ALT_MANA_BAR_PAIR_DISPLAY_INFO[class][powerType];
	end

	return false;
end


function widget:OnUpdate()
	if not self:ShouldDisplayPower() then
		self:Hide()
		return
	else
		self:Show()
	end
	
	local unit = self.owner.id
	local class = UnitClass(unit)
	local dead = UnitIsGhost(unit) or UnitIsDead(unit)
	
	local FormIndex = GetShapeshiftForm(unit)
	local powerType = GetPowerType(unit, FormIndex)

	local Max = UnitPowerMax(unit, powerType)
	local current = UnitPower(unit, powerType)

	
	
	if powerType and basePower[powerType] and not ALT_MANA_BAR_PAIR_DISPLAY_INFO[string.upper(class)][powerType] then
	    Max = nil
		current = nil
		dead = true
	end

	
	self:SetValues(current, 0, Max, dead)

	self:UpdateType()
	
end
