local Addon = _G[...]
local profiles = {}

local blackList = {
	point = 1,
	x = 1,
	y = 1,
	anchor = 1,
	["Currency"] = 1,
}

Addon.defaults = {
	["player"] = {
		["overlay"] = {
			["frameLevel"] = 4,
			["frameLayer"] = 1,
			["scale"] = 110,
			["frameStrata"] = 4,
			["y"] = -2,
			["fadeAlpha"] = 100,
			["enable"] = true,
			["anchor"] = "Center",
			["x"] = -21,
			["alpha"] = 100,
			["flipL2R"] = true,
		},
		["debuffs"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["y"] = -76,
			["isTopToBottom"] = true,
			["enable"] = false,
			["columns"] = 6,
			["frameStrata"] = 2,
			["scale"] = 64,
			["isLeftToRight"] = true,
			["x"] = 104,
		},
		["point"] = "TOPLEFT",
		["scale"] = 1,
		["class"] = {
			["textY"] = -8,
			["enable"] = true,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["arcMid"] = -9,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["sparkSize"] = 39,
			["height"] = 64,
			["drop"] = false,
			["x"] = 0,
			["scale"] = 100,
		},
		["altPower"] = {
			["maxTextWidth"] = 1000,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["textY"] = 0,
			["textVert"] = 2,
			["backdropOpacity"] = 50,
			["drop"] = true,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = -106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["currency"] = {
			["scale"] = 64,
			["fadeAlpha"] = 100,
			["Goal"] = {
				["Artifact Points"] = 138650,
			},
			["anchor"] = "BottomLeft",
			["lifeTime_Track"] = {
			},
			["showBG"] = false,
			["AutoWatch"] = true,
			["frameStrata"] = 2,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["advLog"] = false,
			["enable"] = false,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["isTopToBottom"] = false,
			["x"] = 12,
			["ThisSession"] = {
			},
			["height"] = 54,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["watchIndex"] = 2,
			["lifeTime"] = {
			},
		},
		["cast"] = {
			["textPoint"] = "Left",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 5,
			["anchor"] = "Left",
			["testTexture"] = false,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["y"] = 20,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 16,
			["anchorText"] = "Center",
			["textY"] = 0,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = 2,
			["textureName"] = "Blizzard",
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["showBG"] = false,
			["yTextOffset"] = 0,
			["reverseArc"] = false,
			["frameLevel"] = 2,
			["x"] = 108,
			["sparkY"] = 0,
			["width"] = 117,
			["alpha"] = 100,
			["timeX"] = 0,
			["scale"] = 100,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["frameStrata"] = 3,
			["textX"] = 0,
			["maxTextWidth"] = 98,
			["rotate"] = false,
			["timePoint"] = "Right",
		},
		["showstates"] = "",
		["Goal"] = {
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 20,
			["scale"] = 100,
			["alpha"] = 100,
			["y"] = -14,
			["x"] = 45,
			["mouseOverTooltip"] = true,
			["anchor"] = "TopLeft",
			["fadeAlpha"] = 100,
			["frameStrata"] = 3,
			["enable"] = true,
		},
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -59,
			["x"] = 119,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["scale"] = 91,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "HORIZONTAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["frameLevel"] = 2,
			["enable"] = true,
			["reverseArc"] = false,
			["textVert"] = 2,
			["maxTextWidth"] = 300,
			["textHori"] = 2,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 129,
			["textX"] = 0,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["leftOffset"] = 0,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["level"] = {
			["frameLevel"] = 11,
			["frameLayer"] = 1,
			["scale"] = 100,
			["fadeAlpha"] = 100,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = -16,
			["x"] = -61,
			["justifyH"] = 2,
			["alpha"] = 100,
			["height"] = 12,
			["frameStrata"] = 4,
			["anchor"] = "Center",
			["enable"] = true,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["enable"] = true,
			["fadeAlpha"] = 100,
			["spacing"] = 3,
			["anchor"] = "Bottom",
			["angle"] = 0,
			["showBG"] = false,
			["columns"] = 5,
			["frameLevel"] = 11,
			["compress"] = 0,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["scale"] = 101,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 3,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["x"] = 51,
			["height"] = 50,
			["isLeftToRight"] = true,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = -106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["height"] = 12,
			["textX"] = 0,
			["frameStrata"] = 2,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["textVert"] = 2,
			["alpha"] = 100,
			["topOffset"] = 0,
		},
		["showInPetBattleUI"] = false,
		["threat"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["scale"] = 100,
			["fadeAlpha"] = 100,
			["justifyV"] = 1,
			["width"] = 35,
			["y"] = -10,
			["x"] = 2,
			["justifyH"] = 3,
			["alpha"] = 100,
			["anchor"] = "top",
			["frameStrata"] = 2,
			["height"] = 12,
			["enable"] = true,
		},
		["health"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 0,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -46,
			["x"] = 122,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["scale"] = 91,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["yTextOffset"] = 0,
			["orient"] = "HORIZONTAL",
			["justifyH"] = 2,
			["drop"] = true,
			["enable"] = true,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textVert"] = 2,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textX"] = 0,
			["textY"] = 0,
			["height"] = 12,
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 126,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["leftOffset"] = 0,
			["rigtOffset"] = 1,
			["rotate"] = true,
			["xTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["power"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["orient"] = "HORIZONTAL",
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["y"] = -73,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["scale"] = 91,
			["x"] = 121,
			["alpha"] = 100,
			["frameStrata"] = 2,
			["width"] = 126,
			["textY"] = 0,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textX"] = 0,
			["leftOffset"] = 0,
			["rotate"] = true,
			["height"] = 12,
			["topOffset"] = 0,
		},
		["background"] = {
			["enable"] = true,
			["textureName"] = "Blizzard Tooltip",
			["fadeAlpha"] = 100,
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "TopLeft",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["edgecolor"] = {
				["a"] = 100,
				["r"] = 100,
				["g"] = 100,
				["b"] = 100,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = -25,
			["x"] = 112,
			["alpha"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["height"] = 18,
			["scale"] = 100,
			["color"] = {
				["a"] = 0.5,
				["r"] = 0.317647058823529,
				["g"] = 0.305882352941177,
				["b"] = 0.301960784313726,
			},
			["ReactionColor"] = true,
		},
		["showInOverrideUI"] = false,
		["frameStrata"] = 1,
		["width"] = 232,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = -13,
			["angle"] = 227,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 3,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 6,
			["isTopToBottom"] = true,
			["style"] = "ROUND",
			["reverse"] = false,
			["height"] = 45,
			["spin"] = -154,
			["rev"] = false,
			["enable"] = true,
			["spacing"] = 0,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 8,
			["compress"] = 0,
			["frameLevel"] = 24,
			["frameStrata"] = 4,
			["width"] = 45,
			["IsTopToBottom"] = true,
			["rings"] = 1,
			["anchor"] = "Left",
			["scale"] = 106,
			["x"] = 44,
			["IsLeftToRight"] = false,
			["alpha"] = 100,
			["isLeftToRight"] = true,
		},
		["frameLayer"] = 1,
		["name"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["enable"] = true,
			["fadeAlpha"] = 100,
			["justifyV"] = 2,
			["width"] = 114,
			["y"] = -26,
			["x"] = -8,
			["justifyH"] = 2,
			["alpha"] = 100,
			["anchor"] = "TopRight",
			["frameStrata"] = 2,
			["height"] = 12,
			["scale"] = 100,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomLeft",
			["zoom"] = 0,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["width"] = 133,
			["rotation"] = 0,
			["x"] = -110,
			["alpha"] = 100,
			["height"] = 197,
			["clickThru"] = true,
			["scale"] = 50,
			["y"] = -45,
		},
		["height"] = 100,
		["buffs"] = {
			["scale"] = 64,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["y"] = -31,
			["x"] = 104,
			["enable"] = false,
			["columns"] = 6,
			["frameStrata"] = 2,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["isLeftToRight"] = true,
			["isTopToBottom"] = true,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomRight",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textVert"] = 2,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = -106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textX"] = 0,
		},
		["clickThrough"] = false,
	},
	["focus"] = {
		["debuffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["y"] = -76,
			["isTopToBottom"] = true,
			["columns"] = 6,
			["reverse"] = false,
			["isLeftToRight"] = true,
			["scale"] = 64,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["x"] = -104,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["enable"] = true,
			["fadeAlpha"] = 100,
			["spacing"] = 3,
			["anchor"] = "Bottom",
			["angle"] = 0,
			["showBG"] = false,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["columns"] = 5,
			["compress"] = 0,
			["scale"] = 101,
			["x"] = -51,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 3,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["frameLayer"] = 1,
			["height"] = 50,
			["isLeftToRight"] = true,
			["alpha"] = 100,
			["frameLevel"] = 11,
		},
		["class"] = {
			["textY"] = -8,
			["enable"] = true,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = false,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["x"] = 0,
			["height"] = 64,
			["sparkSize"] = 39,
			["scale"] = 100,
			["arcMid"] = -9,
		},
		["cast"] = {
			["textPoint"] = "Left",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 5,
			["anchor"] = "Right",
			["showBG"] = false,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["y"] = 20,
			["x"] = -108,
			["arc"] = 0,
			["height"] = 16,
			["anchorText"] = "Center",
			["maxTextWidth"] = 98,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = 2,
			["sparkY"] = 0,
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["reverseArc"] = false,
			["textX"] = 0,
			["textureName"] = "Blizzard",
			["scale"] = 100,
			["width"] = 117,
			["frameStrata"] = 3,
			["timeX"] = 0,
			["frameLevel"] = 2,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["alpha"] = 100,
			["textY"] = 0,
			["rotate"] = false,
			["timePoint"] = "Right",
			["testTexture"] = false,
		},
		["clickThrough"] = false,
		["anchor"] = "playerBC",
		["level"] = {
			["frameLevel"] = 11,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = -16,
			["x"] = 61,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["height"] = 12,
			["anchor"] = "Center",
			["enable"] = true,
			["frameStrata"] = 4,
		},
		["threat"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 1,
			["width"] = 35,
			["y"] = -10,
			["x"] = -2,
			["justifyH"] = 1,
			["fadeAlpha"] = 100,
			["anchor"] = "top",
			["enable"] = true,
			["height"] = 12,
			["frameStrata"] = 2,
		},
		["frameLayer"] = 1,
		["showInOverrideUI"] = false,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = -13,
			["angle"] = 227,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 3,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 6,
			["x"] = -44,
			["style"] = "ROUND",
			["reverse"] = false,
			["height"] = 45,
			["spin"] = -154,
			["rev"] = false,
			["enable"] = true,
			["spacing"] = 0,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 8,
			["compress"] = 0,
			["frameLevel"] = 24,
			["alpha"] = 100,
			["width"] = 45,
			["isLeftToRight"] = true,
			["rings"] = 1,
			["isTopToBottom"] = true,
			["scale"] = 106,
			["anchor"] = "Right",
			["frameStrata"] = 4,
			["IsTopToBottom"] = true,
			["IsLeftToRight"] = false,
		},
		["y"] = -100,
		["name"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["enable"] = true,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 114,
			["y"] = -26,
			["x"] = 8,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["anchor"] = "TopLeft",
			["height"] = 12,
			["scale"] = 100,
			["frameStrata"] = 2,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomRight",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["width"] = 133,
			["rotation"] = 0,
			["x"] = 110,
			["alpha"] = 100,
			["height"] = 197,
			["zoom"] = 0,
			["scale"] = 50,
			["y"] = -45,
		},
		["height"] = 100,
		["buffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["x"] = -104,
			["y"] = -31,
			["isTopToBottom"] = true,
			["columns"] = 6,
			["reverse"] = false,
			["alpha"] = 100,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["scale"] = 64,
			["frameStrata"] = 2,
		},
		["overlay"] = {
			["frameLevel"] = 4,
			["frameLayer"] = 1,
			["enable"] = true,
			["frameStrata"] = 4,
			["y"] = -2,
			["fadeAlpha"] = 100,
			["flipL2R"] = false,
			["anchor"] = "Center",
			["alpha"] = 100,
			["x"] = 21,
			["scale"] = 110,
		},
		["point"] = "TOPLEFT",
		["scale"] = 1,
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomLeft",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textVert"] = 2,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = 106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textX"] = 0,
		},
		["showstates"] = "",
		["Goal"] = {
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 20,
			["scale"] = 100,
			["alpha"] = 100,
			["y"] = -14,
			["x"] = -45,
			["mouseOverTooltip"] = true,
			["anchor"] = "TopRight",
			["fadeAlpha"] = 100,
			["enable"] = true,
			["frameStrata"] = 3,
		},
		["showInPetBattleUI"] = false,
		["power"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -73,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["yTextOffset"] = 0,
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["scale"] = 91,
			["leftOffset"] = 0,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 126,
			["textY"] = 0,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["rotate"] = true,
			["x"] = -121,
			["topOffset"] = 0,
		},
		["alpha"] = 1,
		["width"] = 232,
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = 106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["height"] = 12,
			["textX"] = 0,
			["frameStrata"] = 2,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["textVert"] = 2,
			["alpha"] = 100,
			["topOffset"] = 0,
		},
		["health"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 0,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -46,
			["x"] = -122,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["rotate"] = true,
			["yTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["textY"] = 0,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textVert"] = 2,
			["textX"] = 0,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 126,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["frameLevel"] = 2,
			["rigtOffset"] = 1,
			["scale"] = 91,
			["xTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["currency"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["fadeAlpha"] = 100,
			["Goal"] = {
				["Artifact Points"] = 138650,
			},
			["anchor"] = "BottomRight",
			["lifeTime_Track"] = {
			},
			["showBG"] = false,
			["AutoWatch"] = true,
			["alpha"] = 100,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["advLog"] = false,
			["scale"] = 64,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 6,
			["ThisSession"] = {
			},
			["x"] = -12,
			["isTopToBottom"] = false,
			["height"] = 54,
			["enable"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {
			},
		},
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -59,
			["x"] = -119,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["scale"] = 91,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "HORIZONTAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textY"] = 0,
			["textHori"] = 2,
			["alpha"] = 100,
			["frameStrata"] = 2,
			["width"] = 129,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["leftOffset"] = 0,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["background"] = {
			["color"] = {
				["a"] = 0.5,
				["b"] = 0.301960784313726,
				["g"] = 0.305882352941177,
				["r"] = 0.317647058823529,
			},
			["textureName"] = "Blizzard Tooltip",
			["fadeAlpha"] = 100,
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "TopRight",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["edgecolor"] = {
				["a"] = 100,
				["b"] = 100,
				["g"] = 100,
				["r"] = 100,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = -25,
			["x"] = -110,
			["alpha"] = 100,
			["enable"] = true,
			["height"] = 18,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["ReactionColor"] = true,
		},
		["altPower"] = {
			["maxTextWidth"] = 1000,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["textY"] = 0,
			["textVert"] = 2,
			["backdropOpacity"] = 50,
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = 106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["frameStrata"] = 1,
	},
	["target"] = {
		["debuffs"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["frameStrata"] = 2,
			["y"] = -76,
			["isTopToBottom"] = true,
			["columns"] = 6,
			["reverse"] = false,
			["isLeftToRight"] = true,
			["scale"] = 64,
			["enable"] = false,
			["x"] = -104,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["enable"] = true,
			["fadeAlpha"] = 100,
			["spacing"] = 3,
			["anchor"] = "Bottom",
			["angle"] = 0,
			["showBG"] = false,
			["frameStrata"] = 2,
			["columns"] = 5,
			["compress"] = 0,
			["frameLayer"] = 1,
			["x"] = -51,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 3,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["scale"] = 101,
			["height"] = 50,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["isLeftToRight"] = true,
			["frameLevel"] = 11,
		},
		["class"] = {
			["textY"] = -8,
			["scale"] = 100,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = false,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["x"] = 0,
			["height"] = 64,
			["enable"] = true,
			["arcMid"] = -9,
			["sparkSize"] = 39,
		},
		["cast"] = {
			["textPoint"] = "Left",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 5,
			["anchor"] = "Right",
			["showBG"] = false,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["y"] = 20,
			["x"] = -108,
			["arc"] = 0,
			["height"] = 16,
			["anchorText"] = "Center",
			["maxTextWidth"] = 98,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = 2,
			["textureName"] = "Blizzard",
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["reverseArc"] = false,
			["textX"] = 0,
			["sparkY"] = 0,
			["scale"] = 100,
			["width"] = 117,
			["frameStrata"] = 3,
			["timeX"] = 0,
			["frameLevel"] = 2,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["alpha"] = 100,
			["textY"] = 0,
			["rotate"] = false,
			["testTexture"] = false,
			["timePoint"] = "Right",
		},
		["clickThrough"] = false,
		["anchor"] = "playerRC",
		["level"] = {
			["frameLevel"] = 11,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = -16,
			["x"] = 61,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["height"] = 12,
			["anchor"] = "Center",
			["enable"] = true,
			["frameStrata"] = 4,
		},
		["threat"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 1,
			["width"] = 35,
			["y"] = -10,
			["x"] = -2,
			["justifyH"] = 1,
			["fadeAlpha"] = 100,
			["anchor"] = "top",
			["enable"] = true,
			["height"] = 12,
			["frameStrata"] = 2,
		},
		["frameLayer"] = 1,
		["showInOverrideUI"] = false,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = -13,
			["angle"] = 227,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 3,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 6,
			["x"] = -44,
			["style"] = "ROUND",
			["reverse"] = false,
			["height"] = 45,
			["spin"] = -154,
			["rev"] = false,
			["enable"] = true,
			["spacing"] = 0,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 8,
			["compress"] = 0,
			["frameLevel"] = 24,
			["alpha"] = 100,
			["width"] = 45,
			["frameStrata"] = 4,
			["rings"] = 1,
			["isTopToBottom"] = true,
			["scale"] = 106,
			["anchor"] = "Right",
			["isLeftToRight"] = true,
			["IsTopToBottom"] = true,
			["IsLeftToRight"] = false,
		},
		["x"] = 232,
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = 106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["height"] = 12,
			["textX"] = 0,
			["frameStrata"] = 2,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["textVert"] = 2,
			["alpha"] = 100,
			["topOffset"] = 0,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomRight",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["width"] = 133,
			["rotation"] = 0,
			["x"] = 110,
			["alpha"] = 100,
			["height"] = 197,
			["zoom"] = 0,
			["scale"] = 50,
			["y"] = -45,
		},
		["height"] = 100,
		["buffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["isTopToBottom"] = true,
			["y"] = -31,
			["x"] = -104,
			["columns"] = 6,
			["reverse"] = false,
			["alpha"] = 100,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["scale"] = 64,
			["isLeftToRight"] = true,
		},
		["overlay"] = {
			["frameLevel"] = 4,
			["frameLayer"] = 1,
			["scale"] = 110,
			["frameStrata"] = 4,
			["y"] = -2,
			["x"] = 21,
			["fadeAlpha"] = 100,
			["anchor"] = "Center",
			["enable"] = true,
			["alpha"] = 100,
			["flipL2R"] = false,
		},
		["point"] = "TOPLEFT",
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -59,
			["x"] = -119,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["scale"] = 91,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "HORIZONTAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textY"] = 0,
			["textHori"] = 2,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 129,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["textVert"] = 2,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomLeft",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textVert"] = 2,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = 106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textX"] = 0,
		},
		["altPower"] = {
			["maxTextWidth"] = 1000,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["textY"] = 0,
			["textVert"] = 2,
			["backdropOpacity"] = 50,
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = 106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["Goal"] = {
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 20,
			["scale"] = 100,
			["alpha"] = 100,
			["y"] = -14,
			["x"] = -45,
			["mouseOverTooltip"] = true,
			["anchor"] = "TopRight",
			["fadeAlpha"] = 100,
			["enable"] = true,
			["frameStrata"] = 4,
		},
		["showInPetBattleUI"] = false,
		["power"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -73,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["yTextOffset"] = 0,
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["scale"] = 91,
			["leftOffset"] = 0,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 126,
			["textY"] = 0,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["x"] = -121,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["alpha"] = 1,
		["width"] = 232,
		["showstates"] = "",
		["health"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 0,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -46,
			["x"] = -122,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["yTextOffset"] = 0,
			["rotate"] = true,
			["justifyH"] = 2,
			["drop"] = true,
			["textY"] = 0,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["textVert"] = 2,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 126,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["frameLevel"] = 2,
			["rigtOffset"] = 1,
			["scale"] = 91,
			["xTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["currency"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["fadeAlpha"] = 100,
			["Goal"] = {
				["Artifact Points"] = 138650,
			},
			["AutoWatch"] = true,
			["lifeTime_Track"] = {
			},
			["anchor"] = "BottomRight",
			["enable"] = false,
			["scale"] = 64,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["showBG"] = false,
			["isTopToBottom"] = false,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["x"] = -12,
			["frameStrata"] = 2,
			["ThisSession"] = {
			},
			["height"] = 54,
			["advLog"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {
			},
		},
		["scale"] = 1,
		["background"] = {
			["color"] = {
				["a"] = 0.5,
				["b"] = 0.301960784313726,
				["g"] = 0.305882352941177,
				["r"] = 0.317647058823529,
			},
			["textureName"] = "Blizzard Tooltip",
			["fadeAlpha"] = 100,
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "TopRight",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["edgecolor"] = {
				["a"] = 100,
				["b"] = 100,
				["g"] = 100,
				["r"] = 100,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = -25,
			["x"] = -110,
			["alpha"] = 100,
			["enable"] = true,
			["height"] = 18,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["ReactionColor"] = true,
		},
		["frameStrata"] = 1,
		["name"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["enable"] = true,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 114,
			["y"] = -26,
			["x"] = 8,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["anchor"] = "TopLeft",
			["height"] = 12,
			["scale"] = 100,
			["frameStrata"] = 2,
		},
	},
	["focustarget"] = {
		["debuffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["y"] = -76,
			["isTopToBottom"] = true,
			["columns"] = 6,
			["reverse"] = false,
			["isLeftToRight"] = true,
			["scale"] = 64,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["x"] = -104,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["enable"] = true,
			["fadeAlpha"] = 100,
			["spacing"] = 3,
			["anchor"] = "Bottom",
			["angle"] = 0,
			["showBG"] = false,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["columns"] = 5,
			["compress"] = 0,
			["scale"] = 101,
			["x"] = -51,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 3,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["frameLayer"] = 1,
			["height"] = 50,
			["isLeftToRight"] = true,
			["alpha"] = 100,
			["frameLevel"] = 11,
		},
		["class"] = {
			["textY"] = -8,
			["enable"] = true,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = false,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["x"] = 0,
			["height"] = 64,
			["sparkSize"] = 39,
			["scale"] = 100,
			["arcMid"] = -9,
		},
		["cast"] = {
			["textPoint"] = "Left",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 5,
			["anchor"] = "Right",
			["showBG"] = false,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["y"] = 20,
			["x"] = -108,
			["arc"] = 0,
			["height"] = 16,
			["anchorText"] = "Center",
			["maxTextWidth"] = 98,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = 2,
			["sparkY"] = 0,
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["reverseArc"] = false,
			["textX"] = 0,
			["textureName"] = "Blizzard",
			["scale"] = 100,
			["width"] = 117,
			["frameStrata"] = 3,
			["timeX"] = 0,
			["frameLevel"] = 2,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["alpha"] = 100,
			["textY"] = 0,
			["rotate"] = false,
			["timePoint"] = "Right",
			["testTexture"] = false,
		},
		["clickThrough"] = false,
		["anchor"] = "focusRB",
		["level"] = {
			["frameLevel"] = 11,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = -16,
			["x"] = 61,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["height"] = 12,
			["anchor"] = "Center",
			["enable"] = true,
			["frameStrata"] = 4,
		},
		["threat"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 1,
			["width"] = 35,
			["y"] = -10,
			["x"] = -2,
			["justifyH"] = 1,
			["fadeAlpha"] = 100,
			["anchor"] = "top",
			["enable"] = true,
			["height"] = 12,
			["frameStrata"] = 2,
		},
		["frameLayer"] = 1,
		["showInOverrideUI"] = false,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = -13,
			["angle"] = 227,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 3,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 6,
			["x"] = -44,
			["style"] = "ROUND",
			["reverse"] = false,
			["height"] = 45,
			["spin"] = -154,
			["rev"] = false,
			["enable"] = true,
			["spacing"] = 0,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 8,
			["compress"] = 0,
			["frameLevel"] = 24,
			["alpha"] = 100,
			["width"] = 45,
			["isLeftToRight"] = true,
			["rings"] = 1,
			["isTopToBottom"] = true,
			["scale"] = 106,
			["anchor"] = "Right",
			["frameStrata"] = 4,
			["IsTopToBottom"] = true,
			["IsLeftToRight"] = false,
		},
		["y"] = -100,
		["x"] = 232,
		["name"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["enable"] = true,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 114,
			["y"] = -26,
			["x"] = 8,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["anchor"] = "TopLeft",
			["height"] = 12,
			["scale"] = 100,
			["frameStrata"] = 2,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomRight",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["width"] = 133,
			["rotation"] = 0,
			["x"] = 110,
			["alpha"] = 100,
			["height"] = 197,
			["zoom"] = 0,
			["scale"] = 50,
			["y"] = -45,
		},
		["height"] = 100,
		["buffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["x"] = -104,
			["y"] = -31,
			["isTopToBottom"] = true,
			["columns"] = 6,
			["reverse"] = false,
			["alpha"] = 100,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["scale"] = 64,
			["frameStrata"] = 2,
		},
		["overlay"] = {
			["frameLevel"] = 4,
			["frameLayer"] = 1,
			["enable"] = true,
			["frameStrata"] = 4,
			["y"] = -2,
			["fadeAlpha"] = 100,
			["flipL2R"] = false,
			["anchor"] = "Center",
			["alpha"] = 100,
			["x"] = 21,
			["scale"] = 110,
		},
		["point"] = "TOPLEFT",
		["scale"] = 0.79,
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomLeft",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textVert"] = 2,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = 106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textX"] = 0,
		},
		["showstates"] = "",
		["Goal"] = {
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 20,
			["scale"] = 100,
			["alpha"] = 100,
			["y"] = -14,
			["x"] = -45,
			["mouseOverTooltip"] = true,
			["anchor"] = "TopRight",
			["fadeAlpha"] = 100,
			["enable"] = true,
			["frameStrata"] = 3,
		},
		["showInPetBattleUI"] = false,
		["power"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -73,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["yTextOffset"] = 0,
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["scale"] = 91,
			["leftOffset"] = 0,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 126,
			["textY"] = 0,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["rotate"] = true,
			["x"] = -121,
			["topOffset"] = 0,
		},
		["frameStrata"] = 1,
		["width"] = 232,
		["padH"] = 1,
		["padW"] = 1,
		["health"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 0,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -46,
			["x"] = -122,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["rotate"] = true,
			["yTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["textY"] = 0,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textVert"] = 2,
			["textX"] = 0,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 126,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["frameLevel"] = 2,
			["rigtOffset"] = 1,
			["scale"] = 91,
			["xTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -59,
			["x"] = -119,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["scale"] = 91,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "HORIZONTAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textY"] = 0,
			["textHori"] = 2,
			["alpha"] = 100,
			["frameStrata"] = 2,
			["width"] = 129,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["leftOffset"] = 0,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["background"] = {
			["color"] = {
				["a"] = 0.5,
				["b"] = 0.301960784313726,
				["g"] = 0.305882352941177,
				["r"] = 0.317647058823529,
			},
			["textureName"] = "Blizzard Tooltip",
			["fadeAlpha"] = 100,
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "TopRight",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["edgecolor"] = {
				["a"] = 100,
				["b"] = 100,
				["g"] = 100,
				["r"] = 100,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = -25,
			["x"] = -110,
			["alpha"] = 100,
			["enable"] = true,
			["height"] = 18,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["ReactionColor"] = true,
		},
		["currency"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["fadeAlpha"] = 100,
			["Goal"] = {
				["Artifact Points"] = 138650,
			},
			["anchor"] = "BottomRight",
			["lifeTime_Track"] = {
			},
			["showBG"] = false,
			["AutoWatch"] = true,
			["alpha"] = 100,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["advLog"] = false,
			["scale"] = 64,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 6,
			["ThisSession"] = {
			},
			["x"] = -12,
			["isTopToBottom"] = false,
			["height"] = 54,
			["enable"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {
			},
		},
		["altPower"] = {
			["maxTextWidth"] = 1000,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["textY"] = 0,
			["textVert"] = 2,
			["backdropOpacity"] = 50,
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = 106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = 106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["height"] = 12,
			["textX"] = 0,
			["frameStrata"] = 2,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["textVert"] = 2,
			["alpha"] = 100,
			["topOffset"] = 0,
		},
	},
	["targettarget"] = {
		["debuffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["y"] = -76,
			["isTopToBottom"] = true,
			["columns"] = 6,
			["reverse"] = false,
			["isLeftToRight"] = true,
			["scale"] = 64,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["x"] = -104,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["fadeAlpha"] = 100,
			["spacing"] = 3,
			["anchor"] = "Bottom",
			["angle"] = 0,
			["showBG"] = false,
			["frameLevel"] = 11,
			["columns"] = 5,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["enable"] = true,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 3,
			["x"] = -51,
			["style"] = "Bar",
			["scale"] = 101,
			["height"] = 50,
			["isTopToBottom"] = false,
			["compress"] = 0,
			["frameStrata"] = 2,
		},
		["class"] = {
			["textY"] = -8,
			["scale"] = 100,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = false,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["x"] = 0,
			["height"] = 64,
			["enable"] = true,
			["arcMid"] = -9,
			["sparkSize"] = 39,
		},
		["padW"] = 1,
		["clickThrough"] = false,
		["anchor"] = "targetRB",
		["level"] = {
			["frameLevel"] = 11,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = -16,
			["x"] = 61,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["height"] = 12,
			["anchor"] = "Center",
			["enable"] = true,
			["frameStrata"] = 4,
		},
		["threat"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 1,
			["width"] = 35,
			["y"] = -10,
			["x"] = -2,
			["justifyH"] = 1,
			["fadeAlpha"] = 100,
			["anchor"] = "top",
			["enable"] = true,
			["height"] = 12,
			["frameStrata"] = 2,
		},
		["frameLayer"] = 1,
		["showInOverrideUI"] = false,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = -13,
			["angle"] = 227,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 3,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 6,
			["x"] = -44,
			["style"] = "ROUND",
			["reverse"] = false,
			["height"] = 45,
			["spin"] = -154,
			["rev"] = false,
			["enable"] = true,
			["spacing"] = 0,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 8,
			["compress"] = 0,
			["frameLevel"] = 24,
			["alpha"] = 100,
			["width"] = 45,
			["isLeftToRight"] = true,
			["rings"] = 1,
			["isTopToBottom"] = true,
			["scale"] = 106,
			["anchor"] = "Right",
			["frameStrata"] = 4,
			["IsTopToBottom"] = true,
			["IsLeftToRight"] = false,
		},
		["y"] = -188,
		["x"] = -448,
		["name"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["enable"] = true,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 114,
			["y"] = -26,
			["x"] = 8,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["anchor"] = "TopLeft",
			["height"] = 12,
			["scale"] = 100,
			["frameStrata"] = 2,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomRight",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["width"] = 133,
			["rotation"] = 0,
			["x"] = 110,
			["alpha"] = 100,
			["height"] = 197,
			["zoom"] = 0,
			["scale"] = 50,
			["y"] = -45,
		},
		["padH"] = 1,
		["buffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["isTopToBottom"] = true,
			["y"] = -31,
			["x"] = -104,
			["columns"] = 6,
			["reverse"] = false,
			["isLeftToRight"] = true,
			["scale"] = 64,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["frameStrata"] = 2,
		},
		["overlay"] = {
			["frameLevel"] = 4,
			["frameLayer"] = 1,
			["scale"] = 110,
			["frameStrata"] = 4,
			["y"] = -2,
			["x"] = 21,
			["fadeAlpha"] = 100,
			["anchor"] = "Center",
			["enable"] = true,
			["alpha"] = 100,
			["flipL2R"] = false,
		},
		["point"] = "TOP",
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -59,
			["x"] = -119,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["scale"] = 91,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "HORIZONTAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textY"] = 0,
			["textHori"] = 2,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 129,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["textVert"] = 2,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomLeft",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textVert"] = 2,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = 106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textX"] = 0,
		},
		["altPower"] = {
			["maxTextWidth"] = 1000,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["textY"] = 0,
			["textVert"] = 2,
			["backdropOpacity"] = 50,
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = 106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["Goal"] = {
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 20,
			["scale"] = 100,
			["alpha"] = 100,
			["y"] = -14,
			["x"] = -45,
			["mouseOverTooltip"] = true,
			["anchor"] = "TopRight",
			["fadeAlpha"] = 100,
			["enable"] = true,
			["frameStrata"] = 3,
		},
		["showInPetBattleUI"] = false,
		["power"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -73,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["yTextOffset"] = 0,
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["scale"] = 91,
			["leftOffset"] = 0,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 126,
			["textY"] = 0,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["x"] = -121,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["frameStrata"] = 1,
		["width"] = 232,
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = 106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["height"] = 12,
			["textX"] = 0,
			["frameStrata"] = 2,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["textVert"] = 2,
			["alpha"] = 100,
			["topOffset"] = 0,
		},
		["scale"] = 0.79,
		["health"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 0,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -46,
			["x"] = -122,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["textY"] = 0,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["textVert"] = 2,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 126,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["frameLevel"] = 2,
			["rigtOffset"] = 1,
			["scale"] = 91,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["height"] = 100,
		["showstates"] = "",
		["cast"] = {
			["textPoint"] = "Left",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 5,
			["anchor"] = "Right",
			["testTexture"] = false,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["y"] = 20,
			["x"] = -108,
			["arc"] = 0,
			["height"] = 16,
			["anchorText"] = "Center",
			["maxTextWidth"] = 98,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = 2,
			["sparkY"] = 0,
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["showBG"] = false,
			["yTextOffset"] = 0,
			["reverseArc"] = false,
			["textX"] = 0,
			["xTextOffset"] = 0,
			["textureName"] = "Blizzard",
			["width"] = 117,
			["frameStrata"] = 3,
			["timeX"] = 0,
			["scale"] = 100,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["alpha"] = 100,
			["frameLevel"] = 2,
			["textY"] = 0,
			["timePoint"] = "Right",
			["rotate"] = false,
		},
		["currency"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["fadeAlpha"] = 100,
			["Goal"] = {
				["Artifact Points"] = 138650,
			},
			["AutoWatch"] = true,
			["lifeTime_Track"] = {
			},
			["showBG"] = false,
			["anchor"] = "BottomRight",
			["frameStrata"] = 2,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["enable"] = false,
			["isTopToBottom"] = false,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["ThisSession"] = {
			},
			["scale"] = 64,
			["x"] = -12,
			["height"] = 54,
			["advLog"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {
			},
		},
		["background"] = {
			["color"] = {
				["a"] = 0.5,
				["b"] = 0.301960784313726,
				["g"] = 0.305882352941177,
				["r"] = 0.317647058823529,
			},
			["textureName"] = "Blizzard Tooltip",
			["fadeAlpha"] = 100,
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "TopRight",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["edgecolor"] = {
				["a"] = 100,
				["b"] = 100,
				["g"] = 100,
				["r"] = 100,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = -25,
			["x"] = -110,
			["alpha"] = 100,
			["enable"] = true,
			["height"] = 18,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["ReactionColor"] = true,
		},
	},
	["playerpet"] = {
		["debuffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["y"] = -76,
			["isTopToBottom"] = true,
			["columns"] = 6,
			["reverse"] = false,
			["isLeftToRight"] = true,
			["scale"] = 64,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["x"] = -104,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["enable"] = true,
			["fadeAlpha"] = 100,
			["spacing"] = 3,
			["anchor"] = "Bottom",
			["angle"] = 0,
			["showBG"] = false,
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["frameLevel"] = 11,
			["compress"] = 0,
			["scale"] = 101,
			["x"] = -51,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 3,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["frameLayer"] = 1,
			["height"] = 50,
			["isLeftToRight"] = true,
			["alpha"] = 100,
			["columns"] = 5,
		},
		["class"] = {
			["textY"] = -8,
			["scale"] = 100,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = false,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["x"] = 0,
			["height"] = 64,
			["arcMid"] = -9,
			["enable"] = true,
			["sparkSize"] = 39,
		},
		["cast"] = {
			["textPoint"] = "Left",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 5,
			["anchor"] = "Right",
			["showBG"] = false,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["y"] = 20,
			["x"] = -108,
			["arc"] = 0,
			["height"] = 16,
			["anchorText"] = "Center",
			["maxTextWidth"] = 98,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = 2,
			["sparkY"] = 0,
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["reverseArc"] = false,
			["textX"] = 0,
			["textureName"] = "Blizzard",
			["scale"] = 100,
			["width"] = 117,
			["frameStrata"] = 3,
			["timeX"] = 0,
			["frameLevel"] = 2,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["alpha"] = 100,
			["textY"] = 0,
			["rotate"] = false,
			["timePoint"] = "Right",
			["testTexture"] = false,
		},
		["fadeAlpha"] = 0.65,
		["clickThrough"] = false,
		["anchor"] = "focusBC",
		["background"] = {
			["color"] = {
				["a"] = 0.5,
				["b"] = 0.301960784313726,
				["g"] = 0.305882352941177,
				["r"] = 0.317647058823529,
			},
			["textureName"] = "Blizzard Tooltip",
			["fadeAlpha"] = 100,
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "TopRight",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["edgecolor"] = {
				["a"] = 100,
				["b"] = 100,
				["g"] = 100,
				["r"] = 100,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = -25,
			["x"] = -110,
			["alpha"] = 100,
			["enable"] = true,
			["height"] = 18,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["ReactionColor"] = true,
		},
		["threat"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 1,
			["width"] = 35,
			["y"] = -10,
			["x"] = -2,
			["justifyH"] = 1,
			["fadeAlpha"] = 100,
			["anchor"] = "top",
			["enable"] = true,
			["height"] = 12,
			["frameStrata"] = 2,
		},
		["frameLayer"] = 1,
		["showInOverrideUI"] = false,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = -13,
			["angle"] = 227,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 3,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 6,
			["x"] = -44,
			["style"] = "ROUND",
			["reverse"] = false,
			["height"] = 45,
			["spin"] = -154,
			["rev"] = false,
			["enable"] = true,
			["spacing"] = 0,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 8,
			["compress"] = 0,
			["frameLevel"] = 24,
			["alpha"] = 100,
			["width"] = 45,
			["isLeftToRight"] = true,
			["rings"] = 1,
			["isTopToBottom"] = true,
			["scale"] = 106,
			["anchor"] = "Right",
			["frameStrata"] = 4,
			["IsTopToBottom"] = true,
			["IsLeftToRight"] = false,
		},
		["y"] = -200,
		["x"] = 1,
		["name"] = {
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["enable"] = true,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 114,
			["y"] = -26,
			["x"] = 8,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["anchor"] = "TopLeft",
			["height"] = 12,
			["scale"] = 100,
			["frameStrata"] = 2,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomRight",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["width"] = 133,
			["rotation"] = 0,
			["x"] = 110,
			["alpha"] = 100,
			["height"] = 197,
			["zoom"] = 0,
			["scale"] = 50,
			["y"] = -45,
		},
		["padH"] = -1,
		["buffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["isTopToBottom"] = true,
			["y"] = -31,
			["x"] = -104,
			["columns"] = 6,
			["reverse"] = false,
			["isLeftToRight"] = true,
			["scale"] = 64,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["frameStrata"] = 2,
		},
		["overlay"] = {
			["frameLevel"] = 4,
			["frameLayer"] = 1,
			["enable"] = true,
			["frameStrata"] = 4,
			["y"] = -2,
			["fadeAlpha"] = 100,
			["flipL2R"] = false,
			["anchor"] = "Center",
			["alpha"] = 100,
			["x"] = 21,
			["scale"] = 110,
		},
		["point"] = "TOPLEFT",
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -59,
			["x"] = -119,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["scale"] = 91,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "HORIZONTAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["frameLevel"] = 2,
			["leftOffset"] = 0,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textY"] = 0,
			["textX"] = 0,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 129,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textHori"] = 2,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["yTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomLeft",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textVert"] = 2,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = 106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textX"] = 0,
		},
		["showstates"] = "",
		["Goal"] = {
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 20,
			["scale"] = 100,
			["alpha"] = 100,
			["y"] = -14,
			["x"] = -45,
			["mouseOverTooltip"] = true,
			["anchor"] = "TopRight",
			["fadeAlpha"] = 100,
			["enable"] = true,
			["frameStrata"] = 3,
		},
		["showInPetBattleUI"] = false,
		["power"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -73,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["yTextOffset"] = 0,
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["textVert"] = 2,
			["reverseArc"] = false,
			["frameLevel"] = 2,
			["textX"] = 0,
			["scale"] = 91,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 126,
			["textY"] = 0,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["leftOffset"] = 0,
			["orient"] = "HORIZONTAL",
			["rotate"] = true,
			["x"] = -121,
			["topOffset"] = 0,
		},
		["currency"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 1,
				["g"] = 1,
				["b"] = 1,
			},
			["fadeAlpha"] = 100,
			["Goal"] = {
				["Artifact Points"] = 138650,
			},
			["anchor"] = "BottomRight",
			["lifeTime_Track"] = {
			},
			["showBG"] = false,
			["AutoWatch"] = true,
			["alpha"] = 100,
			["frameLevel"] = 2,
			["frameLayer"] = 1,
			["advLog"] = false,
			["scale"] = 64,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 6,
			["ThisSession"] = {
			},
			["x"] = -12,
			["isTopToBottom"] = false,
			["height"] = 54,
			["enable"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {
			},
		},
		["frameStrata"] = 1,
		["width"] = 232,
		["alpha"] = 1,
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = 106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["height"] = 12,
			["textX"] = 0,
			["frameStrata"] = 2,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["textVert"] = 2,
			["alpha"] = 100,
			["topOffset"] = 0,
		},
		["health"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["arcMid"] = 0,
			["anchor"] = "TopRight",
			["format"] = "value",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "percent",
			["y"] = -46,
			["x"] = -122,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["rotate"] = true,
			["yTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["textY"] = 0,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textVert"] = 2,
			["leftOffset"] = 0,
			["reverseArc"] = false,
			["frameLevel"] = 2,
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 126,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textX"] = 0,
			["rigtOffset"] = 1,
			["scale"] = 91,
			["xTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["scale"] = 1,
		["altPower"] = {
			["maxTextWidth"] = 1000,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["textY"] = 0,
			["textVert"] = 2,
			["backdropOpacity"] = 50,
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = 106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["padW"] = -1,
		["level"] = {
			["frameLevel"] = 11,
			["frameLayer"] = 1,
			["scale"] = 100,
			["alpha"] = 100,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = -16,
			["x"] = 61,
			["justifyH"] = 2,
			["fadeAlpha"] = 100,
			["height"] = 12,
			["anchor"] = "Center",
			["enable"] = true,
			["frameStrata"] = 4,
		},
		["height"] = 100,
	},
}
	
Addon.Advanced = {
	["player"] = {
		["overlay"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = false,
			["frameStrata"] = 2,
			["y"] = 0,
			["x"] = 0,
			["anchor"] = "Center",
			["alpha"] = 100,
			["fadeAlpha"] = 100,
			["scale"] = 100,
			["flipL2R"] = true,
		},
		["debuffs"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["rows"] = 3,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "Bottom",
			["showBG"] = false,
			["columns"] = 6,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["y"] = 69,
			["isTopToBottom"] = true,
			["x"] = 42,
			["enable"] = false,
			["scale"] = 76,
			["isLeftToRight"] = true,
			["frameLevel"] = 1,
			["alpha"] = 100,
		},
		["resource"] = {
			["rotateIcons"] = 46,
			["scale"] = 100,
			["fadeAlpha"] = 100,
			["spacing"] = 6,
			["anchor"] = "Bottom",
			["angle"] = 122,
			["showBG"] = false,
			["enable"] = true,
			["columns"] = 5,
			["compress"] = 30,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["isTopToBottom"] = true,
			["alpha"] = 100,
			["width"] = 149,
			["y"] = 28,
			["x"] = 0,
			["style"] = "Bar",
			["frameLayer"] = 1,
			["height"] = 175,
			["frameStrata"] = 2,
			["isLeftToRight"] = true,
			["frameLevel"] = 1,
		},
		["altpower"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 50,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 11,
			["mouseover"] = "value",
			["y"] = -15,
			["x"] = 0,
			["arc"] = 0,
			["height"] = 106,
			["anchorText"] = "BottomLeft",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["scale"] = 100,
			["justifyV"] = 1,
			["textureName"] = "Aluminium",
			["justifyH"] = 1,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "VERTICAL",
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["frameLevel"] = 11,
			["enable"] = true,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textHori"] = 2,
			["textY"] = -2,
			["frameStrata"] = 3,
			["alpha"] = 100,
			["width"] = 17,
			["textX"] = -2,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["yTextOffset"] = 0,
			["leftOffset"] = 0,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["class"] = {
			["textY"] = -8,
			["enable"] = true,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["arcMid"] = -9,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["sparkSize"] = 39,
			["height"] = 64,
			["drop"] = false,
			["x"] = 0,
			["scale"] = 100,
		},
		["background"] = {
			["enable"] = false,
			["textureName"] = "Blizzard Tooltip",
			["edgecolor"] = {
				["a"] = 100,
				["b"] = 100,
				["g"] = 100,
				["r"] = 100,
			},
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "Center",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["bgPad"] = 0,
			["frameStrata"] = 1,
			["width"] = 94,
			["y"] = 1,
			["x"] = 0,
			["scale"] = 100,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 1,
				["r"] = 0.588235294117647,
			},
			["height"] = 100,
			["ReactionColor"] = true,
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["cast"] = {
			["textPoint"] = "Left",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 166,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["arcMid"] = 5,
			["anchor"] = "Top",
			["showBG"] = true,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["timeY"] = 2,
			["y"] = -2,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 16,
			["anchorText"] = "Left",
			["maxTextWidth"] = 100,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = 3,
			["textureName"] = "Aluminium",
			["Sparkarc"] = 0,
			["justifyH"] = 1,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["testTexture"] = false,
			["yTextOffset"] = 0,
			["reverseArc"] = false,
			["frameLevel"] = 3,
			["x"] = 0,
			["sparkY"] = 0,
			["timeX"] = 0,
			["frameStrata"] = 1,
			["width"] = 167,
			["scale"] = 100,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["alpha"] = 100,
			["textX"] = 0,
			["textY"] = 4,
			["rotate"] = false,
			["timePoint"] = "Right",
		},
		["currency"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["fadeAlpha"] = 100,
			["Goal"] = {
			},
			["anchor"] = "Bottom",
			["showBG"] = false,
			["lifeTime_Track"] = {

			},
			["AutoWatch"] = true,
			["alpha"] = 100,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["advLog"] = true,
			["enable"] = true,
			["frameStrata"] = 2,
			["width"] = 164,
			["y"] = -160,
			["ThisSession"] = {

			},
			["x"] = -7,
			["isTopToBottom"] = false,
			["height"] = 54,
			["scale"] = 64,
			["watchIndex"] = 4,
			["lifeTime"] = {},
		},
		["Goal"] = {

		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 80,
			["alpha"] = 100,
			["y"] = 0,
			["x"] = -36,
			["mouseOverTooltip"] = true,
			["anchor"] = "Left",
			["frameStrata"] = 2,
			["enable"] = false,
			["fadeAlpha"] = 100,
		},
		["clickThrough"] = false,
		["level"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 100,
			["frameStrata"] = 1,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = 0,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["height"] = 26,
			["anchor"] = "Right",
			["enable"] = true,
			["alpha"] = 100,
			["x"] = 4,
		},
		["scale"] = 0.9,
		["frameLayer"] = 100,
		["showInPetBattleUI"] = false,
		["threat"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 100,
			["frameStrata"] = 2,
			["justifyV"] = 3,
			["width"] = 35,
			["y"] = 11,
			["fadeAlpha"] = 100,
			["justifyH"] = 3,
			["anchor"] = "Bottom",
			["height"] = 12,
			["enable"] = true,
			["alpha"] = 100,
			["x"] = 0,
		},
		["health"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 50,
			["backdropOpacity"] = 100,
			["arcMid"] = 0,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 8,
			["mouseover"] = "value",
			["y"] = -15,
			["x"] = 1,
			["arc"] = 0,
			["textHori"] = 3,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["yTextOffset"] = 0,
			["orient"] = "VERTICAL",
			["justifyH"] = 3,
			["drop"] = true,
			["scale"] = 100,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["frameLevel"] = 8,
			["textVert"] = 1,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textY"] = 0,
			["height"] = 106,
			["frameStrata"] = 3,
			["alpha"] = 100,
			["width"] = 34,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textX"] = -135,
			["rigtOffset"] = 1,
			["rotate"] = true,
			["xTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["power"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 50,
			["backdropOpacity"] = 35,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 2,
			["mouseover"] = "value",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["textHori"] = 3,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 1,
			["textureName"] = "Aluminium",
			["LifeTime"] = 0,
			["y"] = -15,
			["justifyH"] = 1,
			["drop"] = true,
			["orient"] = "VERTICAL",
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["textY"] = 8,
			["frameLevel"] = 2,
			["reverseArc"] = false,
			["textVert"] = 2,
			["scale"] = 100,
			["x"] = -16,
			["alpha"] = 100,
			["frameStrata"] = 5,
			["width"] = 17,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["leftOffset"] = 0,
			["textX"] = 141,
			["rotate"] = true,
			["height"] = 106,
			["topOffset"] = 0,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = -106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameStrata"] = 2,
			["leftOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textY"] = 0,
			["enable"] = true,
			["textVert"] = 2,
			["height"] = 12,
			["topOffset"] = 0,
		},
		["showInOverrideUI"] = false,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = -13,
			["angle"] = 304,
			["offset"] = -17,
			["s"] = false,
			["frameLayer"] = 55,
			["isLeftToRight"] = false,
			["xArc"] = 0,
			["y"] = 21,
			["x"] = -15,
			["style"] = "BAR",
			["reverse"] = false,
			["height"] = 44,
			["spin"] = -102,
			["rev"] = false,
			["scale"] = 83,
			["spacing"] = 13,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 11,
			["compress"] = 67,
			["yArc"] = 0,
			["IsLeftToRight"] = false,
			["width"] = 42,
			["rings"] = 4,
			["IsTopToBottom"] = true,
			["anchor"] = "Bottom",
			["enable"] = true,
			["isTopToBottom"] = true,
			["frameStrata"] = 8,
			["alpha"] = 100,
			["frameLevel"] = 55,
		},
		["width"] = 169,
		["frameStrata"] = 5,
		["altPower"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["backdropOpacity"] = 50,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["maxTextWidth"] = 1000,
			["textVert"] = 2,
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = -106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["name"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = true,
			["frameStrata"] = 1,
			["justifyV"] = 1,
			["width"] = 219,
			["y"] = 0,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["anchor"] = "Left",
			["height"] = 12,
			["scale"] = 100,
			["alpha"] = 100,
			["x"] = 8,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "TopLeft",
			["deathEffect"] = false,
			["zoom"] = 98,
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["alpha"] = 100,
			["width"] = 307,
			["y"] = 45,
			["x"] = -110,
			["rotation"] = 0,
			["height"] = 207,
			["scale"] = 51,
			["clickThru"] = true,
			["frameStrata"] = 2,
		},
		["height"] = 15,
		["buffs"] = {
			["scale"] = 64,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "TopLeft",
			["showBG"] = false,
			["columns"] = 7,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
			["y"] = 35,
			["x"] = 31,
			["isTopToBottom"] = false,
			["enable"] = false,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["isLeftToRight"] = true,
			["frameLevel"] = 1,
			["alpha"] = 100,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomRight",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = -106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textVert"] = 2,
		},
		["showstates"] = "",
	},
	["focus"] = {
		["overlay"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = false,
			["frameStrata"] = 2,
			["y"] = 0,
			["x"] = 0,
			["anchor"] = "Center",
			["scale"] = 100,
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["debuffs"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["columns"] = 5,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["alpha"] = 100,
			["y"] = -105,
			["x"] = -21,
			["frameStrata"] = 2,
			["reverse"] = false,
			["scale"] = 77,
			["enable"] = true,
			["frameLevel"] = 1,
			["isTopToBottom"] = true,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["enable"] = true,
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["angle"] = 0,
			["showBG"] = false,
			["columns"] = 1,
			["compress"] = 0,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["scale"] = 64,
			["height"] = 50,
			["x"] = 12,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
		},
		["scale"] = 1,
		["class"] = {
			["textY"] = -8,
			["enable"] = true,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = true,
			["anchor"] = "BottomRight",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -51,
			["x"] = 0,
			["height"] = 12,
			["sparkSize"] = 39,
			["scale"] = 100,
			["arcMid"] = -9,
		},
		["padW"] = 3,
		["currency"] = {
			["scale"] = 64,
			["fadeAlpha"] = 50,
			["Goal"] = {
			},
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["frameLevel"] = 50,
			["frameLayer"] = 1,
			["lifeTime_Track"] = {

			},
			["x"] = -12,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["ThisSession"] = {

			},
			["frameStrata"] = 2,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["enable"] = false,
			["isTopToBottom"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {

			},
		},
		["altPower"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["backdropOpacity"] = 50,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["maxTextWidth"] = 1000,
			["textVert"] = 2,
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = -106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 50,
			["alpha"] = 100,
			["y"] = -10,
			["x"] = 5,
			["mouseOverTooltip"] = false,
			["anchor"] = "Top",
			["enable"] = true,
			["frameStrata"] = 2,
			["fadeAlpha"] = 100,
		},
		["cast"] = {
			["textPoint"] = "Center",
			["prevOrient"] = "VERTICAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 57,
			["arcMid"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = true,
			["orient"] = "VERTICAL",
			["textAnchor"] = "Left",
			["frameLayer"] = 3,
			["y"] = -106,
			["x"] = -72,
			["arc"] = 0,
			["height"] = 107,
			["anchorText"] = "TopRight",
			["maxTextWidth"] = 193,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = "MIDDLE",
			["sparkY"] = 0,
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["yTextOffset"] = 0,
			["xTextOffset"] = 24,
			["reverseArc"] = false,
			["textX"] = 26,
			["textureName"] = "Aluminium",
			["scale"] = 100,
			["timeX"] = 0,
			["alpha"] = 100,
			["width"] = 20,
			["frameLevel"] = 3,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["frameStrata"] = 2,
			["textY"] = 50,
			["rotate"] = true,
			["timePoint"] = "Right",
			["testTexture"] = false,
		},
		["level"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 100,
			["enable"] = true,
			["justifyV"] = 2,
			["width"] = 23,
			["y"] = -41,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["anchor"] = "Right",
			["height"] = 12,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = -28,
		},
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["anchor"] = "BottomRight",
			["format"] = "percent",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["x"] = -31,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = 6,
			["scale"] = 100,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "VERTICAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textVert"] = 2,
			["leftOffset"] = 0,
			["reverseArc"] = false,
			["textX"] = 0,
			["textHori"] = 2,
			["maxTextWidth"] = 300,
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 22,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["frameLevel"] = 1,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["padH"] = 3,
		["showInPetBattleUI"] = false,
		["threat"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 73,
			["enable"] = true,
			["justifyV"] = 3,
			["width"] = 35,
			["y"] = -40,
			["fadeAlpha"] = 100,
			["justifyH"] = 3,
			["anchor"] = "Right",
			["height"] = 12,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = -51,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = -106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameStrata"] = 2,
			["leftOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textY"] = 0,
			["enable"] = true,
			["textVert"] = 2,
			["height"] = 12,
			["topOffset"] = 0,
		},
		["frameLayer"] = 4,
		["health"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["arcMid"] = 0,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -14,
			["x"] = 0,
			["arc"] = 0,
			["height"] = 103,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = -6,
			["scale"] = 100,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["rotate"] = true,
			["yTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["enable"] = true,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["maxTextWidth"] = 102,
			["leftOffset"] = 0,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textHori"] = 2,
			["orient"] = "VERTICAL",
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 28,
			["classColor"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textX"] = 0,
			["rigtOffset"] = 1,
			["frameLevel"] = 6,
			["xTextOffset"] = 0,
			["topOffset"] = 55,
		},
		["showInOverrideUI"] = false,
		["frameStrata"] = 4,
		["width"] = 110,
		["power"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 35,
			["anchor"] = "BottomRight",
			["format"] = "current",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["maxTextWidth"] = 98,
			["scale"] = 100,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["yTextOffset"] = 0,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["textHori"] = 2,
			["frameLevel"] = 1,
			["reverseArc"] = false,
			["textVert"] = 2,
			["enable"] = true,
			["leftOffset"] = 0,
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 21,
			["textY"] = 17,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["orient"] = "VERTICAL",
			["textX"] = -1,
			["rotate"] = true,
			["x"] = -53,
			["topOffset"] = 0,
		},
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = 0,
			["angle"] = 111,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 1,
			["isLeftToRight"] = false,
			["xArc"] = 0,
			["y"] = 43,
			["isTopToBottom"] = true,
			["style"] = "BAR",
			["reverse"] = true,
			["height"] = 200,
			["spin"] = 0,
			["enable"] = true,
			["spacing"] = -2,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["frameLevel"] = 1,
			["compress"] = 58,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 96,
			["yArc"] = 0,
			["rings"] = 1,
			["IsTopToBottom"] = true,
			["scale"] = 95,
			["IsLeftToRight"] = false,
			["anchor"] = "BottomLeft",
			["x"] = 0,
			["columns"] = 6,
		},
		["name"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = true,
			["scale"] = 100,
			["justifyV"] = 3,
			["width"] = 94,
			["y"] = 9,
			["fadeAlpha"] = 100,
			["justifyH"] = 3,
			["height"] = 26,
			["anchor"] = "Right",
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = 0,
		},
		["model"] = {
			["enable"] = true,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomLeft",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 2,
			["frameLayer"] = 2,
			["frameStrata"] = 2,
			["width"] = 121,
			["y"] = -92,
			["x"] = -99,
			["rotation"] = 0,
			["height"] = 150,
			["scale"] = 114,
			["zoom"] = 78,
			["alpha"] = 100,
		},
		["height"] = 10,
		["buffs"] = {
			["scale"] = 77,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["columns"] = 5,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["isTopToBottom"] = true,
			["y"] = -50,
			["x"] = -21,
			["frameStrata"] = 2,
			["reverse"] = false,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["enable"] = false,
			["frameLevel"] = 1,
			["isLeftToRight"] = true,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopRight",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -41,
			["x"] = -106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textVert"] = 2,
		},
		["background"] = {
			["enable"] = false,
			["textureName"] = "Blizzard Tooltip",
			["edgecolor"] = {
				["a"] = 100,
				["r"] = 100,
				["g"] = 100,
				["b"] = 100,
			},
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "Right",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["color"] = {
				["a"] = 0.5,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 100,
			["y"] = 0,
			["x"] = -1,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["height"] = 100,
			["ReactionColor"] = true,
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
	},
	["target"] = {
		["overlay"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = false,
			["frameStrata"] = 2,
			["y"] = 0,
			["x"] = 0,
			["anchor"] = "Center",
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["debuffs"] = {
			["enable"] = true,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["columns"] = 6,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["frameStrata"] = 2,
			["y"] = 118,
			["isTopToBottom"] = false,
			["alpha"] = 100,
			["reverse"] = false,
			["scale"] = 72,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["frameLevel"] = 1,
			["x"] = -111,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["angle"] = 0,
			["showBG"] = false,
			["columns"] = 1,
			["compress"] = 0,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["frameLayer"] = 1,
			["height"] = 50,
			["x"] = 12,
			["scale"] = 64,
			["enable"] = true,
		},
		["scale"] = 1,
		["class"] = {
			["textY"] = -8,
			["scale"] = 100,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = true,
			["anchor"] = "BottomRight",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -51,
			["x"] = 0,
			["height"] = 12,
			["enable"] = true,
			["arcMid"] = -9,
			["sparkSize"] = 39,
		},
		["padW"] = 3,
		["currency"] = {
			["scale"] = 64,
			["Goal"] = {
			},
			["anchor"] = "BottomRight",
			["lifeTime_Track"] = {

			},
			["frameLayer"] = 1,
			["showBG"] = false,
			["x"] = -12,
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 6,
			["ThisSession"] = {

			},
			["isTopToBottom"] = false,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["enable"] = false,
			["alpha"] = 100,
			["watchIndex"] = 2,
			["lifeTime"] = {

			},
		},
		["altPower"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["backdropOpacity"] = 50,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["maxTextWidth"] = 1000,
			["textVert"] = 2,
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = -106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 49,
			["alpha"] = 100,
			["y"] = -10,
			["x"] = 5,
			["mouseOverTooltip"] = false,
			["anchor"] = "Top",
			["enable"] = true,
			["frameStrata"] = 2,
			["fadeAlpha"] = 100,
		},
		["cast"] = {
			["textPoint"] = "Center",
			["prevOrient"] = "VERTICAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 57,
			["arcMid"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = true,
			["orient"] = "VERTICAL",
			["textAnchor"] = "Left",
			["frameLayer"] = 3,
			["timeY"] = -27,
			["y"] = -106,
			["x"] = -70,
			["arc"] = 0,
			["height"] = 107,
			["anchorText"] = "TopRight",
			["textY"] = 50,
			["scale"] = 100,
			["sparkConfig"] = false,
			["justifyV"] = "MIDDLE",
			["textureName"] = "Aluminium",
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["sparkY"] = 0,
			["xTextOffset"] = 24,
			["reverseArc"] = false,
			["textX"] = 26,
			["yTextOffset"] = 0,
			["enable"] = true,
			["timeX"] = 0,
			["alpha"] = 100,
			["width"] = 20,
			["frameLevel"] = 3,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["frameStrata"] = 2,
			["maxTextWidth"] = 193,
			["timePoint"] = "Top",
			["rotate"] = true,
			["testTexture"] = false,
		},
		["background"] = {
			["enable"] = false,
			["textureName"] = "Blizzard Tooltip",
			["edgecolor"] = {
				["a"] = 100,
				["r"] = 100,
				["g"] = 100,
				["b"] = 100,
			},
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "Right",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["color"] = {
				["a"] = 0.5,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 100,
			["y"] = 0,
			["x"] = -1,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["height"] = 100,
			["ReactionColor"] = true,
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["anchor"] = "BottomRight",
			["format"] = "percent",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["x"] = -30,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = 10,
			["scale"] = 100,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "VERTICAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["textVert"] = 2,
			["reverseArc"] = false,
			["textX"] = 0,
			["textHori"] = 2,
			["maxTextWidth"] = 300,
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 22,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["frameLevel"] = 1,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["padH"] = 3,
		["showInPetBattleUI"] = false,
		["threat"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 101,
			["enable"] = true,
			["justifyV"] = 2,
			["width"] = 35,
			["y"] = 70,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["anchor"] = "Right",
			["height"] = 12,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = -47,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = -106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameStrata"] = 2,
			["leftOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textY"] = 0,
			["enable"] = true,
			["textVert"] = 2,
			["height"] = 12,
			["topOffset"] = 0,
		},
		["frameLayer"] = 4,
		["health"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["arcMid"] = 0,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -14,
			["x"] = 0,
			["arc"] = 0,
			["height"] = 103,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = 0,
			["scale"] = 100,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["yTextOffset"] = 0,
			["rotate"] = true,
			["justifyH"] = 2,
			["drop"] = true,
			["enable"] = true,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["maxTextWidth"] = 102,
			["frameLevel"] = 1,
			["reverseArc"] = false,
			["textX"] = 0,
			["textHori"] = 2,
			["orient"] = "VERTICAL",
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 30,
			["classColor"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["leftOffset"] = 0,
			["rigtOffset"] = 1,
			["textVert"] = 2,
			["xTextOffset"] = 0,
			["topOffset"] = 55,
		},
		["showInOverrideUI"] = false,
		["frameStrata"] = 4,
		["width"] = 110,
		["power"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 34.9551048278809,
			["anchor"] = "BottomRight",
			["format"] = "current",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["maxTextWidth"] = 98,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["textHori"] = 2,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["yTextOffset"] = 0,
			["frameLevel"] = 1,
			["reverseArc"] = false,
			["textVert"] = 2,
			["leftOffset"] = 0,
			["scale"] = 100,
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 21,
			["textY"] = 19,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["orient"] = "VERTICAL",
			["textX"] = -1,
			["rotate"] = true,
			["x"] = -52,
			["topOffset"] = 0,
		},
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = 0,
			["angle"] = 111,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 1,
			["isLeftToRight"] = false,
			["xArc"] = 0,
			["y"] = 43,
			["isTopToBottom"] = true,
			["style"] = "BAR",
			["reverse"] = true,
			["height"] = 200,
			["spin"] = 0,
			["enable"] = true,
			["spacing"] = -2,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["frameLevel"] = 1,
			["compress"] = 58,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 96,
			["yArc"] = 0,
			["rings"] = 1,
			["IsTopToBottom"] = true,
			["scale"] = 95,
			["IsLeftToRight"] = false,
			["anchor"] = "BottomLeft",
			["x"] = 0,
			["columns"] = 6,
		},
		["name"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = true,
			["scale"] = 100,
			["justifyV"] = 3,
			["width"] = 94,
			["y"] = 9,
			["fadeAlpha"] = 100,
			["justifyH"] = 3,
			["height"] = 26,
			["anchor"] = "Right",
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = 0,
		},
		["model"] = {
			["enable"] = true,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomLeft",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 2,
			["frameLayer"] = 2,
			["frameStrata"] = 2,
			["width"] = 121,
			["y"] = -92,
			["x"] = -99,
			["rotation"] = 0,
			["height"] = 150,
			["scale"] = 114,
			["zoom"] = 78,
			["alpha"] = 100,
		},
		["height"] = 10,
		["buffs"] = {
			["scale"] = 72,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["columns"] = 6,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["x"] = -111,
			["y"] = 66,
			["isTopToBottom"] = false,
			["isLeftToRight"] = true,
			["reverse"] = false,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["enable"] = true,
			["frameLevel"] = 1,
			["frameStrata"] = 4,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopRight",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -41,
			["x"] = -106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textVert"] = 2,
		},
		["level"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 100,
			["enable"] = true,
			["justifyV"] = 2,
			["width"] = 23,
			["y"] = -41,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["anchor"] = "Right",
			["height"] = 12,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = -28,
		},
	},
	["playerpet"] = {
		["debuffs"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["rows"] = 3,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "Bottom",
			["showBG"] = false,
			["columns"] = 6,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["alpha"] = 100,
			["y"] = 69,
			["x"] = 42,
			["frameStrata"] = 2,
			["reverse"] = false,
			["scale"] = 76,
			["enable"] = false,
			["frameLevel"] = 1,
			["isTopToBottom"] = true,
		},
		["resource"] = {
			["rotateIcons"] = 46,
			["enable"] = true,
			["spacing"] = 6,
			["anchor"] = "Bottom",
			["angle"] = 122,
			["showBG"] = false,
			["columns"] = 5,
			["compress"] = 30,
			["scale"] = 100,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["frameStrata"] = 2,
			["width"] = 149,
			["y"] = 28,
			["isTopToBottom"] = true,
			["style"] = "Bar",
			["x"] = 0,
			["height"] = 175,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["isLeftToRight"] = true,
		},
		["class"] = {
			["textY"] = -8,
			["scale"] = 100,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = false,
			["anchor"] = "Center",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 207,
			["y"] = -5,
			["x"] = 0,
			["height"] = 64,
			["arcMid"] = -9,
			["enable"] = true,
			["sparkSize"] = 39,
		},
		["cast"] = {
			["textPoint"] = "Center",
			["prevOrient"] = "HORIZONTAL",
			["multi"] = true,
			["textheight"] = 166,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["arcMid"] = 5,
			["anchor"] = "Top",
			["showBG"] = true,
			["orient"] = "HORIZONTAL",
			["textAnchor"] = "Center",
			["frameLayer"] = 3,
			["y"] = 4,
			["x"] = 0,
			["arc"] = 37,
			["height"] = 16,
			["anchorText"] = "Left",
			["maxTextWidth"] = 289,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = "MIDDLE",
			["sparkY"] = 1,
			["Sparkarc"] = -69,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = -135.303436279297,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["reverseArc"] = false,
			["textX"] = 0,
			["textureName"] = "Aluminium",
			["scale"] = 100,
			["timeX"] = 0,
			["alpha"] = 100,
			["width"] = 165,
			["frameLevel"] = 3,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["frameStrata"] = 1,
			["textY"] = 0,
			["rotate"] = false,
			["timePoint"] = "Right",
			["testTexture"] = false,
		},
		["fadeAlpha"] = 0.65,
		["clickThrough"] = false,
		["level"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 100,
			["enable"] = true,
			["justifyV"] = 2,
			["width"] = 25,
			["y"] = 0,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["anchor"] = "Right",
			["height"] = 26,
			["frameStrata"] = 1,
			["alpha"] = 100,
			["x"] = 4,
		},
		["threat"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 100,
			["enable"] = true,
			["justifyV"] = 3,
			["width"] = 35,
			["y"] = 11,
			["fadeAlpha"] = 100,
			["justifyH"] = 3,
			["anchor"] = "Bottom",
			["height"] = 12,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = 0,
		},
		["frameLayer"] = 4,
		["showInOverrideUI"] = false,
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["anchor"] = "Bottom",
			["angle"] = 304,
			["offset"] = -17,
			["s"] = false,
			["frameLayer"] = 55,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 21,
			["isTopToBottom"] = true,
			["style"] = "BAR",
			["reverse"] = false,
			["height"] = 44,
			["spin"] = -102,
			["rev"] = false,
			["scale"] = 83,
			["spacing"] = 13,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 11,
			["compress"] = 67,
			["isLeftToRight"] = false,
			["IsLeftToRight"] = false,
			["width"] = 42,
			["alpha"] = 100,
			["rings"] = 4,
			["IsTopToBottom"] = true,
			["enable"] = true,
			["frameStrata"] = 8,
			["space"] = -13,
			["x"] = -15,
			["frameLevel"] = 55,
		},
		["name"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = true,
			["scale"] = 100,
			["justifyV"] = 1,
			["width"] = 219,
			["y"] = 0,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["height"] = 12,
			["anchor"] = "Left",
			["frameStrata"] = 1,
			["alpha"] = 100,
			["x"] = 8,
		},
		["model"] = {
			["enable"] = false,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "TopLeft",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["frameStrata"] = 2,
			["width"] = 307,
			["y"] = 45,
			["x"] = -110,
			["rotation"] = 0,
			["height"] = 207,
			["scale"] = 51,
			["zoom"] = 98,
			["alpha"] = 100,
		},
		["padH"] = 3,
		["buffs"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "TopLeft",
			["showBG"] = true,
			["columns"] = 7,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["x"] = 31,
			["y"] = 35,
			["isTopToBottom"] = false,
			["frameStrata"] = 2,
			["reverse"] = false,
			["scale"] = 64,
			["enable"] = false,
			["frameLevel"] = 1,
			["alpha"] = 100,
		},
		["overlay"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = false,
			["frameStrata"] = 2,
			["y"] = 0,
			["x"] = 0,
			["anchor"] = "Center",
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["scale"] = 0.9,
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "BottomRight",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = 41,
			["x"] = -106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textVert"] = 2,
		},
		["currency"] = {
			["scale"] = 64,
			["Goal"] = {
				["Artifact Points"] = 14400,
				["Ancient Mana"] = 400,
			},
			["anchor"] = "Bottom",
			["lifeTime_Track"] = {

			},
			["showBG"] = false,
			["AutoWatch"] = true,
			["alpha"] = 100,
			["frameLayer"] = 1,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["enable"] = true,
			["frameStrata"] = 2,
			["width"] = 164,
			["y"] = -160,
			["x"] = -7,
			["isTopToBottom"] = false,
			["ThisSession"] = {

			},
			["height"] = 54,
			["advLog"] = true,
			["watchIndex"] = 6,
			["lifeTime"] = {

			},
		},
		["Goal"] = {
			["Ancient Mana"] = 180,
			["Artifact Points"] = 9100,
			["Gold"] = 4000,
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 80,
			["alpha"] = 100,
			["y"] = 0,
			["x"] = -36,
			["mouseOverTooltip"] = true,
			["anchor"] = "Left",
			["enable"] = false,
			["frameStrata"] = 2,
			["fadeAlpha"] = 100,
		},
		["showInPetBattleUI"] = false,
		["power"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 4,
			["mouseover"] = "value",
			["y"] = -15,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 106,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["maxTextWidth"] = 300,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["yTextOffset"] = 0,
			["arcEnd"] = 4,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["textHori"] = 3,
			["frameLevel"] = 4,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textX"] = -2,
			["scale"] = 96,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 17,
			["textY"] = 6,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["leftOffset"] = 0,
			["rotate"] = true,
			["orient"] = "VERTICAL",
			["x"] = 0,
			["topOffset"] = 0,
		},
		["frameStrata"] = 4,
		["width"] = 161,
		["height"] = 10,
		["background"] = {
			["enable"] = false,
			["textureName"] = "Blizzard Tooltip",
			["edgecolor"] = {
				["a"] = 100,
				["r"] = 100,
				["g"] = 100,
				["b"] = 100,
			},
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "Center",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bgPad"] = 0,
			["frameStrata"] = 1,
			["width"] = 94,
			["y"] = 1,
			["x"] = 0,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["height"] = 100,
			["ReactionColor"] = true,
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["health"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["arcMid"] = 0,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["showBG"] = true,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -15,
			["x"] = 1,
			["arc"] = 0,
			["height"] = 106,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = -6,
			["enable"] = true,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["rotate"] = true,
			["yTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["maxTextWidth"] = 300,
			["arcEnd"] = 37.0818939208984,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["frameLevel"] = 1,
			["textVert"] = 1,
			["reverseArc"] = false,
			["leftOffset"] = 0,
			["textHori"] = 3,
			["orient"] = "VERTICAL",
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 34,
			["classColor"] = false,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["textX"] = 0,
			["rigtOffset"] = 1,
			["scale"] = 96,
			["xTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["altpower"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["showBG"] = false,
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -15,
			["x"] = 0,
			["arc"] = 0,
			["height"] = 106,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = -6,
			["scale"] = 96,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "VERTICAL",
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["frameLevel"] = 1,
			["leftOffset"] = 0,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textX"] = 0,
			["maxTextWidth"] = 300,
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 34,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["textHori"] = 2,
			["rotate"] = true,
			["xTextOffset"] = 0,
			["yTextOffset"] = 0,
			["topOffset"] = 0,
		},
		["padW"] = 3,
		["altPower"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["backdropOpacity"] = 50,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["maxTextWidth"] = 1000,
			["textVert"] = 2,
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopRight",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = -106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopRight",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = -106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameStrata"] = 2,
			["leftOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textY"] = 0,
			["enable"] = true,
			["textVert"] = 2,
			["height"] = 12,
			["topOffset"] = 0,
		},
		["alpha"] = 1,
	},
	["mouseover"] = {
		["overlay"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = false,
			["frameStrata"] = 2,
			["y"] = 0,
			["x"] = 0,
			["anchor"] = "Center",
			["alpha"] = 100,
			["fadeAlpha"] = 100,
			["scale"] = 100,
		},
		["debuffs"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["columns"] = 5,
			["frameLayer"] = 1,
			["alpha"] = 100,
			["isTopToBottom"] = true,
			["y"] = -105,
			["x"] = 21,
			["isLeftToRight"] = true,
			["reverse"] = false,
			["scale"] = 77,
			["enable"] = false,
			["frameLevel"] = 1,
			["frameStrata"] = 2,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["angle"] = 0,
			["showBG"] = false,
			["columns"] = 1,
			["compress"] = 0,
			["enable"] = true,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["scale"] = 64,
			["height"] = 50,
			["x"] = -12,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
		},
		["scale"] = 1,
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["scale"] = 100,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["textVert"] = 2,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -41,
			["x"] = 106,
			["mouseover"] = "value",
			["textHori"] = 2,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["enable"] = true,
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = false,
			["alpha"] = 100,
			["y"] = -10,
			["x"] = -5,
			["mouseOverTooltip"] = false,
			["anchor"] = "Top",
			["frameStrata"] = 2,
			["scale"] = 50,
			["fadeAlpha"] = 100,
		},
		["level"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 100,
			["frameStrata"] = 2,
			["justifyV"] = 2,
			["width"] = 23,
			["y"] = -41,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["enable"] = true,
			["height"] = 12,
			["anchor"] = "Left",
			["alpha"] = 100,
			["x"] = 28,
		},
		["padW"] = 3,
		["showstates"] = "",
		["class"] = {
			["textY"] = -8,
			["enable"] = true,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = true,
			["anchor"] = "BottomLeft",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -51,
			["x"] = 0,
			["height"] = 12,
			["scale"] = 100,
			["arcMid"] = -9,
			["sparkSize"] = 39,
		},
		["clickThrough"] = true,
		["height"] = 10,
		["background"] = {
			["scale"] = 100,
			["textureName"] = "Blizzard Tooltip",
			["edgecolor"] = {
				["a"] = 100,
				["b"] = 100,
				["g"] = 100,
				["r"] = 100,
			},
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "Left",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["ReactionColor"] = true,
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 100,
			["y"] = 0,
			["x"] = 1,
			["enable"] = false,
			["color"] = {
				["a"] = 0.5,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["height"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["anchor"] = "BottomLeft",
			["format"] = "percent",
			["orient"] = "VERTICAL",
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["x"] = 30,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = 6,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["bottomOffset"] = 100,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["frameLevel"] = 1,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textX"] = 0,
			["maxTextWidth"] = 300,
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 22,
			["scale"] = 100,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["textHori"] = 2,
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = 106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textY"] = 0,
			["scale"] = 100,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["textX"] = 0,
			["height"] = 12,
			["frameStrata"] = 2,
			["width"] = 51,
			["textVert"] = 2,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["maxTextWidth"] = 1000,
			["enable"] = true,
			["orient"] = "HORIZONTAL",
			["alpha"] = 100,
			["topOffset"] = 0,
		},
		["showInPetBattleUI"] = false,
		["threat"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 73,
			["frameStrata"] = 2,
			["justifyV"] = 3,
			["width"] = 35,
			["y"] = -40,
			["fadeAlpha"] = 100,
			["justifyH"] = 1,
			["anchor"] = "Left",
			["height"] = 12,
			["enable"] = true,
			["alpha"] = 100,
			["x"] = 51,
		},
		["frameLayer"] = 4,
		["power"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 35,
			["anchor"] = "BottomLeft",
			["format"] = "current",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["x"] = 52,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = 17,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["orient"] = "VERTICAL",
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["leftOffset"] = 0,
			["textVert"] = 2,
			["reverseArc"] = false,
			["frameLevel"] = 1,
			["textX"] = -1,
			["maxTextWidth"] = 98,
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 21,
			["scale"] = 100,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["textHori"] = 2,
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = 0,
			["angle"] = 111,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 1,
			["yArc"] = 0,
			["xArc"] = 0,
			["y"] = 43,
			["isTopToBottom"] = true,
			["style"] = "BAR",
			["reverse"] = true,
			["height"] = 200,
			["spin"] = 0,
			["scale"] = 90,
			["spacing"] = -2,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["columns"] = 6,
			["compress"] = 58,
			["IsLeftToRight"] = false,
			["alpha"] = 100,
			["width"] = 96,
			["IsTopToBottom"] = true,
			["rings"] = 1,
			["anchor"] = "BottomRight",
			["enable"] = true,
			["frameLevel"] = 1,
			["frameStrata"] = 2,
			["x"] = -12,
			["isLeftToRight"] = false,
		},
		["showInOverrideUI"] = false,
		["frameStrata"] = 4,
		["width"] = 110,
		["name"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = true,
			["frameStrata"] = 2,
			["justifyV"] = 3,
			["width"] = 94,
			["y"] = 9,
			["fadeAlpha"] = 100,
			["justifyH"] = 1,
			["scale"] = 100,
			["anchor"] = "Left",
			["height"] = 26,
			["alpha"] = 100,
			["x"] = 0,
		},
		["currency"] = {
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["Goal"] = {
			},
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["frameLayer"] = 1,
			["lifeTime_Track"] = {

			},
			["ThisSession"] = {

			},
			["frameStrata"] = 2,
			["width"] = 50,
			["y"] = 6,
			["x"] = 12,
			["alpha"] = 100,
			["enable"] = false,
			["scale"] = 64,
			["isTopToBottom"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {

			},
		},
		["health"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["arcMid"] = 0,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -14,
			["x"] = 0,
			["arc"] = 0,
			["height"] = 103,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = -6,
			["scale"] = 100,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["rotate"] = true,
			["xTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["enable"] = true,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["maxTextWidth"] = 102,
			["leftOffset"] = 0,
			["reverseArc"] = false,
			["textVert"] = 2,
			["textHori"] = 2,
			["textX"] = 0,
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 30,
			["classColor"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["frameLevel"] = 1,
			["rigtOffset"] = 1,
			["orient"] = "VERTICAL",
			["yTextOffset"] = 0,
			["topOffset"] = 55,
		},
		["model"] = {
			["enable"] = true,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomRight",
			["deathEffect"] = false,
			["zoom"] = 78,
			["frameLevel"] = 2,
			["frameLayer"] = 2,
			["frameStrata"] = 2,
			["width"] = 121,
			["y"] = -92,
			["x"] = 99,
			["rotation"] = 0,
			["height"] = 150,
			["scale"] = 114,
			["clickThru"] = true,
			["alpha"] = 100,
		},
		["padH"] = 3,
		["buffs"] = {
			["enable"] = false,
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["columns"] = 5,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["x"] = 21,
			["y"] = -50,
			["isTopToBottom"] = true,
			["scale"] = 77,
			["reverse"] = false,
			["color"] = {
				["a"] = 1,
				["b"] = 0,
				["g"] = 0,
				["r"] = 0,
			},
			["frameStrata"] = 2,
			["frameLevel"] = 1,
			["alpha"] = 100,
		},
		["cast"] = {
			["textPoint"] = "Center",
			["prevOrient"] = "VERTICAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 57,
			["arcMid"] = 0,
			["anchor"] = "BottomLeft",
			["testTexture"] = false,
			["orient"] = "VERTICAL",
			["textAnchor"] = "Left",
			["frameLayer"] = 3,
			["timeY"] = 100,
			["yTextOffset"] = 0,
			["x"] = 72,
			["arc"] = 0,
			["height"] = 107,
			["anchorText"] = "TopRight",
			["textY"] = 50,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = "MIDDLE",
			["textureName"] = "Aluminium",
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["xTextOffset"] = 24,
			["sparkY"] = 0,
			["reverseArc"] = false,
			["textX"] = -26,
			["frameLevel"] = 3,
			["y"] = -106,
			["timeX"] = 0,
			["frameStrata"] = 2,
			["width"] = 20,
			["scale"] = 100,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["alpha"] = 100,
			["maxTextWidth"] = 193,
			["timePoint"] = "Right",
			["showBG"] = true,
			["rotate"] = true,
		},
		["altPower"] = {
			["maxTextWidth"] = 1000,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyH"] = "CENTER",
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["textY"] = 0,
			["textX"] = 0,
			["backdropOpacity"] = 50,
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["height"] = 12,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["textVert"] = 2,
			["alpha"] = 100,
			["xTextOffset"] = 0,
			["y"] = -52,
			["mouseover"] = "value",
			["width"] = 51,
			["yTextOffset"] = 0,
			["x"] = 106,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
	},
	["targettarget"] = {
		["overlay"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = false,
			["frameStrata"] = 2,
			["y"] = 0,
			["x"] = 0,
			["anchor"] = "Center",
			["scale"] = 100,
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
		["debuffs"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["columns"] = 5,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["alpha"] = 100,
			["y"] = -105,
			["x"] = 21,
			["frameStrata"] = 2,
			["reverse"] = false,
			["scale"] = 77,
			["enable"] = false,
			["frameLevel"] = 1,
			["isTopToBottom"] = true,
		},
		["resource"] = {
			["rotateIcons"] = 0,
			["enable"] = true,
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["angle"] = 0,
			["showBG"] = false,
			["columns"] = 1,
			["compress"] = 0,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["isTopToBottom"] = false,
			["style"] = "Bar",
			["scale"] = 64,
			["height"] = 50,
			["x"] = -12,
			["frameLayer"] = 1,
			["frameStrata"] = 2,
		},
		["altpower"] = {
			["prevOrient"] = "HORIZONTAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["anchor"] = "BottomLeft",
			["format"] = "percent",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["x"] = 30,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = 6,
			["scale"] = 100,
			["justifyV"] = 2,
			["textureName"] = "Raid",
			["justifyH"] = 2,
			["drop"] = true,
			["LifeTime"] = 0,
			["orient"] = "VERTICAL",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["leftOffset"] = 0,
			["textVert"] = 2,
			["reverseArc"] = false,
			["textX"] = 0,
			["textHori"] = 2,
			["maxTextWidth"] = 300,
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 22,
			["enable"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["yTextOffset"] = 0,
			["frameLevel"] = 1,
			["xTextOffset"] = 0,
			["rotate"] = true,
			["topOffset"] = 0,
		},
		["class"] = {
			["textY"] = -8,
			["scale"] = 100,
			["sparkConfig"] = false,
			["textureName"] = "Bar",
			["drop"] = true,
			["anchor"] = "BottomLeft",
			["arcEnd"] = 47,
			["texturePath"] = "Interface\\Addons\\Dominos_Units\\tex\\bars\\Bar",
			["textX"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -51,
			["x"] = 0,
			["height"] = 12,
			["enable"] = true,
			["sparkSize"] = 39,
			["arcMid"] = -9,
		},
		["padW"] = 3,
		["currency"] = {
			["enable"] = false,
			["Goal"] = {
			},
			["anchor"] = "BottomLeft",
			["showBG"] = false,
			["frameLayer"] = 1,
			["lifeTime_Track"] = {

			},
			["x"] = 12,
			["alpha"] = 100,
			["width"] = 50,
			["y"] = 6,
			["ThisSession"] = {

			},
			["frameStrata"] = 2,
			["scale"] = 64,
			["color"] = {
				["a"] = 1,
				["b"] = 1,
				["g"] = 1,
				["r"] = 1,
			},
			["isTopToBottom"] = false,
			["watchIndex"] = 2,
			["lifeTime"] = {

			},
		},
		["altPower"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["backdropOpacity"] = 50,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["maxTextWidth"] = 1000,
			["textVert"] = 2,
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textHori"] = 2,
			["orient"] = "HORIZONTAL",
			["xTextOffset"] = 0,
			["textX"] = 0,
			["mouseover"] = "value",
			["x"] = 106,
			["yTextOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -52,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["arc"] = 0,
			["height"] = 12,
			["anchorText"] = "Center",
			["percent"] = true,
			["scale"] = 100,
		},
		["focus"] = {
			["usePortrait"] = true,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["scale"] = 50,
			["alpha"] = 100,
			["y"] = -10,
			["x"] = -5,
			["mouseOverTooltip"] = false,
			["anchor"] = "Top",
			["enable"] = true,
			["frameStrata"] = 2,
			["fadeAlpha"] = 100,
		},
		["cast"] = {
			["textPoint"] = "Center",
			["prevOrient"] = "VERTICAL",
			["multi"] = true,
			["textheight"] = 12,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 57,
			["arcMid"] = 0,
			["anchor"] = "BottomLeft",
			["showBG"] = true,
			["orient"] = "VERTICAL",
			["textAnchor"] = "Left",
			["frameLayer"] = 3,
			["y"] = -106,
			["x"] = 72,
			["arc"] = 0,
			["height"] = 107,
			["anchorText"] = "TopRight",
			["textY"] = 50,
			["enable"] = true,
			["sparkConfig"] = false,
			["justifyV"] = "MIDDLE",
			["sparkY"] = 0,
			["Sparkarc"] = 0,
			["justifyH"] = 2,
			["drop"] = false,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["xTextOffset"] = 24,
			["textureName"] = "Aluminium",
			["reverseArc"] = false,
			["textX"] = -26,
			["yTextOffset"] = 0,
			["testTexture"] = false,
			["timeX"] = 0,
			["alpha"] = 100,
			["width"] = 20,
			["scale"] = 100,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = false,
			["frameStrata"] = 2,
			["maxTextWidth"] = 193,
			["frameLevel"] = 3,
			["timePoint"] = "Right",
			["rotate"] = true,
		},
		["level"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 100,
			["enable"] = true,
			["justifyV"] = 2,
			["width"] = 23,
			["y"] = -41,
			["fadeAlpha"] = 100,
			["justifyH"] = 2,
			["anchor"] = "Left",
			["height"] = 12,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = 28,
		},
		["scale"] = 1,
		["height"] = 10,
		["showInPetBattleUI"] = false,
		["threat"] = {
			["frameLevel"] = 3,
			["frameLayer"] = 3,
			["scale"] = 73,
			["enable"] = true,
			["justifyV"] = 3,
			["width"] = 35,
			["y"] = -40,
			["fadeAlpha"] = 100,
			["justifyH"] = 1,
			["anchor"] = "Left",
			["height"] = 12,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = 51,
		},
		["name"] = {
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["enable"] = true,
			["scale"] = 100,
			["justifyV"] = 3,
			["width"] = 94,
			["y"] = 9,
			["fadeAlpha"] = 100,
			["justifyH"] = 1,
			["height"] = 26,
			["anchor"] = "Left",
			["frameStrata"] = 2,
			["alpha"] = 100,
			["x"] = 0,
		},
		["frameLayer"] = 4,
		["health"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 100,
			["arcMid"] = 0,
			["anchor"] = "TopLeft",
			["format"] = "percent",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -14,
			["x"] = 0,
			["arc"] = 0,
			["height"] = 103,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["textY"] = -6,
			["scale"] = 100,
			["LifeTime"] = 0,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["yTextOffset"] = 0,
			["xTextOffset"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["enable"] = true,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["maxTextWidth"] = 102,
			["frameLevel"] = 1,
			["reverseArc"] = false,
			["textX"] = 0,
			["textHori"] = 2,
			["orient"] = "VERTICAL",
			["alpha"] = 100,
			["frameStrata"] = 1,
			["width"] = 30,
			["classColor"] = true,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["leftOffset"] = 0,
			["rigtOffset"] = 1,
			["textVert"] = 2,
			["rotate"] = true,
			["topOffset"] = 55,
		},
		["showInOverrideUI"] = false,
		["frameStrata"] = 4,
		["width"] = 110,
		["power"] = {
			["prevOrient"] = "VERTICAL",
			["CurrentPlayTime"] = 0,
			["rightOffset"] = 100,
			["fadeAlpha"] = 100,
			["backdropOpacity"] = 35,
			["anchor"] = "BottomLeft",
			["format"] = "current",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -103,
			["xTextOffset"] = 0,
			["arc"] = 0,
			["height"] = 65,
			["anchorText"] = "Bottom",
			["percent"] = true,
			["maxTextWidth"] = 98,
			["enable"] = true,
			["justifyV"] = 2,
			["textureName"] = "Aluminium",
			["LifeTime"] = 0,
			["justifyH"] = 2,
			["drop"] = true,
			["textHori"] = 2,
			["arcEnd"] = 0,
			["texturePath"] = "Interface\\Addons\\Recount\\Textures\\statusbar\\Aluminium",
			["yTextOffset"] = 0,
			["frameLevel"] = 1,
			["reverseArc"] = false,
			["textVert"] = 2,
			["leftOffset"] = 0,
			["scale"] = 100,
			["frameStrata"] = 1,
			["alpha"] = 100,
			["width"] = 21,
			["textY"] = 17,
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["orient"] = "VERTICAL",
			["textX"] = -1,
			["rotate"] = true,
			["x"] = 52,
			["topOffset"] = 0,
		},
		["icons"] = {
			["xShift"] = 0,
			["yShift"] = 0,
			["fadeAlpha"] = 100,
			["space"] = 0,
			["angle"] = 111,
			["offset"] = 0,
			["s"] = false,
			["frameLayer"] = 1,
			["isLeftToRight"] = false,
			["xArc"] = 0,
			["y"] = 43,
			["isTopToBottom"] = true,
			["style"] = "BAR",
			["reverse"] = true,
			["height"] = 200,
			["spin"] = 0,
			["enable"] = true,
			["spacing"] = -2,
			["xFlex"] = 0,
			["yFlex"] = 0,
			["frameLevel"] = 1,
			["compress"] = 58,
			["frameStrata"] = 2,
			["alpha"] = 100,
			["width"] = 96,
			["yArc"] = 0,
			["rings"] = 1,
			["IsTopToBottom"] = true,
			["scale"] = 90,
			["IsLeftToRight"] = false,
			["anchor"] = "BottomRight",
			["x"] = -12,
			["columns"] = 6,
		},
		["Health"] = {
			["prevOrient"] = "HORIZONTAL",
			["rightOffset"] = 100,
			["backdropOpacity"] = 50,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["bottomOffset"] = 100,
			["frameLayer"] = 1,
			["mouseover"] = "value",
			["y"] = -41,
			["x"] = 106,
			["arc"] = 0,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["maxTextWidth"] = 1000,
			["scale"] = 100,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["textX"] = 0,
			["frameStrata"] = 2,
			["leftOffset"] = 0,
			["alpha"] = 100,
			["width"] = 51,
			["orient"] = "HORIZONTAL",
			["CurveOffset"] = 0,
			["mouseOverTooltip"] = true,
			["textY"] = 0,
			["enable"] = true,
			["textVert"] = 2,
			["height"] = 12,
			["topOffset"] = 0,
		},
		["model"] = {
			["enable"] = true,
			["justifyV"] = "CENTER",
			["fadeAlpha"] = 100,
			["justifyH"] = "CENTER",
			["anchor"] = "BottomRight",
			["deathEffect"] = false,
			["clickThru"] = true,
			["frameLevel"] = 2,
			["frameLayer"] = 2,
			["frameStrata"] = 2,
			["width"] = 121,
			["y"] = -92,
			["x"] = 99,
			["rotation"] = 0,
			["height"] = 150,
			["scale"] = 114,
			["zoom"] = 78,
			["alpha"] = 100,
		},
		["padH"] = 3,
		["buffs"] = {
			["color"] = {
				["a"] = 1,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["rows"] = 2,
			["fadeAlpha"] = 100,
			["sort"] = "Duration",
			["spacing"] = 0,
			["anchor"] = "BottomRight",
			["showBG"] = false,
			["columns"] = 5,
			["frameLayer"] = 1,
			["isLeftToRight"] = true,
			["x"] = 21,
			["y"] = -50,
			["isTopToBottom"] = true,
			["frameStrata"] = 2,
			["reverse"] = false,
			["scale"] = 77,
			["enable"] = false,
			["frameLevel"] = 1,
			["alpha"] = 100,
		},
		["Class"] = {
			["textY"] = 0,
			["prevOrient"] = "HORIZONTAL",
			["enable"] = true,
			["justifyV"] = "CENTER",
			["textureName"] = "Raid",
			["justifyH"] = "CENTER",
			["drop"] = true,
			["anchor"] = "TopLeft",
			["format"] = "value",
			["texturePath"] = "Interface\\TargetingFrame\\UI-StatusBar",
			["orient"] = "HORIZONTAL",
			["textX"] = 0,
			["scale"] = 100,
			["alpha"] = 100,
			["width"] = 51,
			["y"] = -41,
			["x"] = 106,
			["mouseover"] = "value",
			["height"] = 12,
			["textHori"] = 2,
			["anchorText"] = "Center",
			["percent"] = true,
			["textVert"] = 2,
		},
		["background"] = {
			["enable"] = false,
			["textureName"] = "Blizzard Tooltip",
			["edgecolor"] = {
				["a"] = 100,
				["r"] = 100,
				["g"] = 100,
				["b"] = 100,
			},
			["edgeFile"] = "Interface\\ACHIEVEMENTFRAME\\UI-Achievement-WoodBorder",
			["anchor"] = "Left",
			["inset"] = 0,
			["edgeSize"] = 13,
			["frameLevel"] = 1,
			["frameLayer"] = 1,
			["color"] = {
				["a"] = 0.5,
				["r"] = 0,
				["g"] = 0,
				["b"] = 0,
			},
			["bgPad"] = 0,
			["frameStrata"] = 2,
			["width"] = 100,
			["y"] = 0,
			["x"] = 1,
			["scale"] = 100,
			["texturePath"] = "Interface\\Tooltips\\UI-Tooltip-Background",
			["height"] = 100,
			["ReactionColor"] = true,
			["alpha"] = 100,
			["fadeAlpha"] = 100,
		},
	},
}

local defaults  = {
	frames = {
		player = true,
		target = true,
		targettarget = true,
		focus = true,
		focustarget = true,
		playerpet = true,
	},
	hide = {
		PlayerFrame = true,
		TargetFrame = true,
		FocusFrame = true,
	}
}

local function getSets()
	Addon.master.db.profile.units = Addon.master.db.profile.units or defaults
	Addon.master.db.profile.units.hide = Addon.master.db.profile.units.hide or Addon.master.db.profile.units.disable or {
		PlayerFrame = true,
		TargetFrame = true,
		FocusFrame = true,
	}
	return Addon.master.db.profile.units
end

Addon.getSets = getSets

local basics = {
	defaults = Addon.defaults,
	Advanced = Addon.Advanced,
}

local files = {}
local info  = {}
function profiles:GetProfiles()
	files = {}
		for profile, settings in pairs(CopyTable(DominosDB.profiles or {})) do
			for i, b in pairs(settings) do
				for id, sets in pairs(settings.frames) do
					if (type(id) == "string") and Addon:IsUnitValid(id) then
						info[id] = Addon.Copy(sets,nil, nil, blackList)
					end
				end
			end
			files[profile] = Addon.Copy(info)--,nil, nil, blackList)
			info = {}                
		end
		for profile, settings in pairs(Addon.Copy(basics,nil, nil, blackList)) do
			files[profile] = settings
		end
	
	Dominos_Units_SV = files
	return files
end

Addon.Profiles = profiles